package IUT.server.logic.tables;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import org.apache.log4j.Logger;

import IUT.server.logic.model.Item;
import IUT.server.logic.model.Title;
import IUT.utilities.Trace;
import Scenario.Utility.FireEvent;

public class TitleTable {
	private Logger logger = Trace.getInstance().getLogger("opreation_file");
	List<Title> titleList=new ArrayList<Title>();
    private static class TitleListHolder {
        private static final TitleTable INSTANCE = new TitleTable();
    }
    private TitleTable(){
    	//set up the default list with some instances
    	String[] ISBNList=new String[]{"9781442668584","9781442616899","9781442667181","9781611687910","9781317594277"};
    	String[] titlenameList=new String[]{"By the grace of God","Dante's lyric poetry ","Courtesy lost","Writing for justice","The act in context"};
    	for(int i=0;i<ISBNList.length;i++){
    		Title detitle=new Title(ISBNList[i],titlenameList[i]);
    		titleList.add(detitle);
		}
    	logger.info(String.format("Operation:Initialize TitleTable;TitleTable: %s", titleList));
    };
    public static final TitleTable getInstance() {
        return TitleListHolder.INSTANCE;
    }
    public boolean DoesTitleExist(String tempTitle){
    	int flag=0;
		for(int i=0;i<titleList.size();i++){
			String ISBN=(titleList.get(i)).getISBN();
			if(ISBN.equalsIgnoreCase(tempTitle)){
				flag=flag+1;
			}else{
				flag=flag+0;	
			}
		}
		if(flag==0){
			return false;
		}else{
			return true;
    	}
    }
    
    public boolean titleHasLoan(String tempTitle){
    	return !LoanTable.getInstance().checkLoan(tempTitle);
    }
	public Object createtitle(String string, String string2) {
		FireEvent.FireAnEvent("titleAdditionRequested",new ArrayList<Object>(Arrays.asList(string,string2,this)));
		boolean result=true;
		int flag=0;
		for(int i=0;i<titleList.size();i++){
			String ISBN=(titleList.get(i)).getISBN();
			if(ISBN.equalsIgnoreCase(string)){
				flag=flag+1;
			}else{
				flag=flag+0;	
			}
		}
		if(flag==0){
			Title newtitle=new Title(string,string2);
			result=titleList.add(newtitle);
			FireEvent.FireAnEvent("newTitleCreated",new ArrayList<Object>(Arrays.asList(string,string2)));
			logger.info(String.format("Operation:Create New Title;Title Info:[%s,%s];State:Success", string,string2));
		}else{
			result=false;
			FireEvent.FireAnEvent("informTitleAlreadyExists",new ArrayList<Object>());
			logger.info(String.format("Operation:Create New Title;Title Info:[%s,%s];State:Fail;Reason:The ISBN already existed.", string,string2));
		}
		FireEvent.FireAnEvent("titleAdditionCompleted",new ArrayList<Object>(Arrays.asList(string)));
		return result;	
	}
	public boolean lookup(String string) {
		boolean result=true;
		int flag=0;
		for(int i=0;i<titleList.size();i++){
			String ISBN=(titleList.get(i)).getISBN();
			if(ISBN.equalsIgnoreCase(string)){
				flag=flag+1;
			}else{
				flag=flag+0;	
			}
		}
		if(flag==0){
			result=false;
		}
		return result;
	}
	public Object delete(String string) {
		FireEvent.FireAnEvent("titleDeletionRequested",new ArrayList<Object>(Arrays.asList(string,this)));
		String result="";
		int index=0;
		int flag=0;
		for(int i=0;i<titleList.size();i++){
			if(titleList.get(i).getISBN().equalsIgnoreCase(string)){
				flag=flag+1;
				index=i;
			}else{
				flag=flag+0;
			}
		}
		if(flag!=0){
			boolean loan=LoanTable.getInstance().checkLoan(string);
			FireEvent.FireAnEvent("checkLoan", new ArrayList<Object>());
			if(loan){
				FireEvent.FireAnEvent("requestDeletion", new ArrayList<Object>(Arrays.asList(string)));
				String string2=titleList.get(index).getBooktitle();
				ItemTable.getInstance().deleteAll(string);
				titleList.remove(index);
				result="success";
				FireEvent.FireAnEvent("titleDeleted",new ArrayList<Object>(Arrays.asList(string)));
				logger.info(String.format("Operation:Delete Title;Title Info:[%s,%s];State:Success", string,string2));
			}else{
				result="Active Loan Exists";
				FireEvent.FireAnEvent("informTitleHasLoan",new ArrayList<Object>());
				logger.info(String.format("Operation:Delete Title;ISBN Info:[%s];State:Fail;Reason:Active Loan Exists.", string));
			}
		}else{
			result="The Title Does Not Exist";
			FireEvent.FireAnEvent("informTitleNotExist",new ArrayList<Object>());
			logger.info(String.format("Operation:Delete Title;ISBN Info:[%s];State:Fail;Reason:The Title Does Not Exist.", string));
		}
		FireEvent.FireAnEvent("titleDeletionCompleted",new ArrayList<Object>(Arrays.asList(string)));
		return result;
	}
	public List<Title> getTitleTable() {
		return titleList;
	}
	
	public List<Integer> getItems(String tempTitle){
		List<Integer> itemListToDelet=new ArrayList<Integer>();
		List<Item> itemList=ItemTable.getInstance().getItemTable();
		for(int i=0;i<itemList.size();i++){
			if(tempTitle.equalsIgnoreCase(itemList.get(i).getISBN())){
				itemListToDelet.add(itemList.get(i).getItemid());
			}
		}
		return itemListToDelet;
	}
    
	


}
