package IUT.server.logic.tables;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.log4j.Logger;

import IUT.server.logic.model.User;
import IUT.utilities.Trace;
import Scenario.Utility.FireEvent;

public class UserTable {
	private Logger logger = Trace.getInstance().getLogger("opreation_file");
	List<User> userList=new ArrayList<User>();
	//could be removed when the observibility methods can take parameters
    private static class UserListHolder {
        private static final UserTable INSTANCE = new UserTable();
    }
    private UserTable(){
    	//set up the default list with some instances
    	String[] passwordList=new String[]{"Zhibo","Yu","Michelle","Kevin","Sun"};
    	String[] usernameList=new String[]{"Zhibo@carleton.ca","Yu@carleton.ca","Michelle@carleton.ca","Kevin@carleton.ca","Sun@carleton.ca"};
    	for(int i=0;i<usernameList.length;i++){
			User deuser=new User(i,usernameList[i],passwordList[i]);
			userList.add(deuser);
		}
    	logger.info(String.format("Operation:Initialize UserTable;UserTable: %s", userList));
    };
    public static final UserTable getInstance() {
        return UserListHolder.INSTANCE;
    }
    
    public boolean DoesUserExist(String tempUser){
    	int flag=0;
		for(int i=0;i<userList.size();i++){
			String email=(userList.get(i)).getUsername();
			if(email.equalsIgnoreCase(tempUser)){
				flag=flag+1;
			}else{
				flag=flag+0;	
			}
		}
		if(flag==0){
			return false;
		}else{
			return true;
    	}
    }
    
    public boolean UserHasLoan(String tempUser){
    	return LoanTable.getInstance().checkUser(lookup(tempUser));
    }
    
    public boolean UserHasFee(String tempUser){
    	return FeeTable.getInstance().lookup(lookup(tempUser));
    }
	public Object createuser(String string, String string2) {
		FireEvent.FireAnEvent("userAdditionRequested",new ArrayList<Object>(Arrays.asList(string,string2,this)));
		boolean result=true;
//		int flag=0;
//		for(int i=0;i<userList.size();i++){
//			String email=(userList.get(i)).getUsername();
//			if(email.equalsIgnoreCase(string)){
//				flag=flag+1;
//			}else{
//				flag=flag+0;	
//			}
//		}
		boolean flag=this.DoesUserExist(string);
		int newUserId = -1;
//		if(flag==0){
		if(!flag){
			User newuser=new User(userList.size(),string,string2);
			newUserId=newuser.getUserid();
			FireEvent.FireAnEvent("generateNewUserId",new ArrayList<Object>(Arrays.asList(string,string2)));
			result=userList.add(newuser);
			FireEvent.FireAnEvent("newUserCreated",new ArrayList<Object>(Arrays.asList(string,string2)));
			logger.info(String.format("Operation:Create New User;User Info:[%s,%s];State:Success", string,string2));
		}else{
			result=false;
			FireEvent.FireAnEvent("reprotUserExists",new ArrayList<Object>());
			logger.info(String.format("Operation:Create New User;User Info:[%s,%s];State:Fail;Reason:The User already existed.", string,string2));
			
		}
		FireEvent.FireAnEvent("userAdditionCompleted",new ArrayList<Object>(Arrays.asList(string,string2)));
		FireEvent.FireAnEvent("userAdditionCompleted",new ArrayList<Object>(Arrays.asList(newUserId)));
		return result;
	}
	public boolean lookup(int j) {
		boolean result=true;
		int flag=0;
		for(int i=0;i<userList.size();i++){
			int userid=(userList.get(i)).getUserid();
			if(userid==j){
				flag=flag+1;
			}else{
				flag=flag+0;	
			}
		}
		if(flag==0){
			result=false;
		}
		return result;
	}
	public List<User> getUserTable() {
		return userList;
	}
	public Object delete(int i) {
		FireEvent.FireAnEvent("userDeletionRequested",new ArrayList<Object>(Arrays.asList(this.lookupUserName(i),this)));
		//Since the userid in "User Creation" is automatically assigned to the user,upon its creation.
		//Each user has a unique userid.Even it is deleted,its userid can not be assigned to other user.
		//To maintain the correctness of the data,here instead delete index from the List.
		//I choose to remove the user's information instead the whole index.Keep its userid as reference.
		String result="";
		boolean flag=this.DoesUserExist(this.lookupUserName(i));
//		boolean loan=LoanTable.getInstance().checkUser(i);
		
		
//		int flag=0;
		int index=0;
		for(int j=0;j<userList.size();j++){
			if(userList.get(j).getUserid()==i){
				index=j;
//				flag=flag+1;
			}else{
//				flag=flag+0;
			}
		}
		
//		if(flag==0){
		if(!flag){
			result="The User Does Not Exist";
			FireEvent.FireAnEvent("informUserNotExist",new ArrayList<Object>());
			logger.info(String.format("Operation:Delete User;User Info:[%s,%s];State:Fail;Reason:The User Does Not Exist.", "N/A","N/A"));
		}else{
//			boolean fee=FeeTable.getInstance().lookup(i);
			boolean loan=this.UserHasLoan(this.lookupUserName(i));
			FireEvent.FireAnEvent("checkUserHasLoan",new ArrayList<Object>());
			boolean fee=this.UserHasFee(this.lookupUserName(i));
			FireEvent.FireAnEvent("checkUserHasFee",new ArrayList<Object>());
			String string=userList.get(index).getUsername();
			String string2=userList.get(index).getPassword();
			if(fee && loan){
				userList.get(index).setUserid(i);
				FireEvent.FireAnEvent("deleteUser",new ArrayList<Object>(Arrays.asList(this.lookupUserName(i))));
				userList.get(index).setPassword("N/A");
				userList.get(index).setUsername("N/A");
				result="success";
				FireEvent.FireAnEvent("userDeleted",new ArrayList<Object>(Arrays.asList(this.lookupUserName(i))));
				logger.info(String.format("Operation:Delete User;User Info:[%s,%s];State:Success", string,string2));
			}else if(fee==false){
				result="Outstanding Fee Exists";
				FireEvent.FireAnEvent("informUserHasFee",new ArrayList<Object>());
				logger.info(String.format("Operation:Delete User;User Info:[%s,%s];State:Fail;Reason:Outstanding Fee Exists.", string,string2));
			}else if(loan==false){
				result="Active Loan Exists";
				FireEvent.FireAnEvent("informUserHasLoan",new ArrayList<Object>());
				logger.info(String.format("Operation:Delete User;User Info:[%s,%s];State:Fail;Reason:Active Loan Exists.", string,string2));
			}
		}
		FireEvent.FireAnEvent("userDeletionCompleted",new ArrayList<Object>(Arrays.asList(this.lookupUserName(i))));
		return result;

	}
	public int lookup(String string) {
		int userid=-1;
		for(int i=0;i<userList.size();i++){
			if(userList.get(i).getUsername().equalsIgnoreCase(string)){
				userid=i;
			}
		}
		return userid;
	}
	public String lookupUserName(int userId) {
		String userName="";
		for(int i=0;i<userList.size();i++){
			if(userList.get(i).getUserid()==userId){
				userName=userList.get(i).getUsername();
			}
		}
		return userName;
	}
	public int checkUser(String string, String string2) {
		int result=0;
		int flag=0;
		int index=0;
		for(int i=0;i<userList.size();i++){
			if(userList.get(i).getUsername().equalsIgnoreCase(string)){
				flag=flag+1;
				index=i;
			}else{
				flag=flag+0;
			}
		}
		boolean password=userList.get(index).getPassword().equalsIgnoreCase(string2);
		if(flag!=0 && password){
			result=0;
		}else if(flag==0){
			result=2;
		}else if(password==false){
			result=1;
		}
		return result;
	}}
