package MonitoringFramework.ACLClass;

import java.util.List;
import java.util.Set;

public interface ACLEventProcessor {
	
	public enum EventProcessorState{
		CREATED,SET,PASSED,FAILED,SKIPPED;
	}
	
	public void setUpToAcceptEvents();
	
	public EventProcessorState getEventProcesorState();
	
	public void processEvent(ACLEventType event);
	
	public List<ACLEventProcessor> getConstituentsEventProcessors();
	
	public ACLEventProcessor getParentEventProcessor();
	
	public void setProcessorStatusToFail();
	
	public void skip(); 
	//calling skip on an event processor(except for scenarios) will set their state to Skipped and they will be not process events or be considered while checking 
	//if the parent event processor passed or not.
	
	
	public List<String> getExpectedEvents();
	
	public Set<String> getForbiddenEvents();

}
