package MonitoringFramework.ACLClass;

import MonitoringFramework.classtrn.ParameterOwner;

public class ACLParameter {
	private String parameterName;
	private Object parameterValue; //could be Integer, String or just an Instance.
	private Boolean hasValue;
	private ParameterOwner owner;
	
	public ACLParameter(String name, Object value, ParameterOwner owner) {
		this.parameterName = name;
		parameterValue = value;
		this.owner = owner;
		hasValue = true;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((hasValue == null) ? 0 : hasValue.hashCode());
		result = prime * result + ((owner == null) ? 0 : owner.hashCode());
		result = prime * result + ((parameterName == null) ? 0 : parameterName.hashCode());
		result = prime * result + ((parameterValue == null) ? 0 : parameterValue.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof ACLParameter)) {
			return false;
		}
		ACLParameter other = (ACLParameter) obj;
		if (hasValue == null) {
			if (other.hasValue != null) {
				return false;
			}
		} else if (!hasValue.equals(other.hasValue)) {
			return false;
		}
		if (owner == null) {
			if (other.owner != null) {
				return false;
			}
		} else if (!owner.equals(other.owner)) {
			return false;
		}
		if (parameterName == null) {
			if (other.parameterName != null) {
				return false;
			}
		} else if (!parameterName.equals(other.parameterName)) {
			return false;
		}
		if (parameterValue == null) {
			if (other.parameterValue != null) {
				return false;
			}
		} else if (!parameterValue.equals(other.parameterValue)) {
			return false;
		}
		return true;
	}

	/**
	 * @return the parameterName
	 */
	public String getParameterName() {
		return parameterName;
	}

	/**
	 * @param parameterName the parameterName to set
	 */
	public void setParameterName(String parameterName) {
		this.parameterName = parameterName;
	}

	/**
	 * @return the parameterValue
	 */
	public Object getParameterValue() {
		return parameterValue;
	}

	/**
	 * @param parameterValue the parameterValue to set
	 */
	public void setParameterValue(Object parameterValue) {
		this.parameterValue = parameterValue;
	}

	/**
	 * @return the hasValue
	 */
	public Boolean getHasValue() {
		return hasValue;
	}

	/**
	 * @param hasValue the hasValue to set
	 */
	public void setHasValue(Boolean hasValue) {
		this.hasValue = hasValue;
	}

	/**
	 * @return the owner
	 */
	public ParameterOwner getOwner() {
		return owner;
	}

	/**
	 * @param owner the owner to set
	 */
	public void setOwner(ParameterOwner owner) {
		this.owner = owner;
	}

	public ACLParameter(String name, ParameterOwner owner) {
		this.parameterName = name;
		this.owner = owner;
		hasValue = false;
	}

}
