package MonitoringFramework.ACLClass;

import java.util.List;
import java.util.Set;

import MonitoringFramework.classtrn.PrintToScreen;


public class ForTaskConstituents implements ACLEventProcessor{
	private final ACLEventProcessor theRepeatedTask;
	private final ForTask ownerTask;
	private final Object expectedParameter;

	public ForTaskConstituents(ForTask ownertask, ACLEventProcessor theRepeatedTask, Object parameter) {
		this.theRepeatedTask = theRepeatedTask;
		this.expectedParameter = parameter;
		this.ownerTask = ownertask;
	}
	
	public ACLEventProcessor getEventProcessor() {
		return theRepeatedTask;
	}

	
	public Object getExpectedParameter() {
		return expectedParameter;
	}


	@Override
	public void setUpToAcceptEvents() {
		theRepeatedTask.setUpToAcceptEvents();		
	}


	@Override
	public EventProcessorState getEventProcesorState() {
		return theRepeatedTask.getEventProcesorState();
	}


	@Override
	public void processEvent(ACLEventType event) {
		if((this.getExpectedEvents().contains(event.getEventName()) && event.canBeObserved() && !this.getEventProcesorState().equals(EventProcessorState.PASSED))){
			String eventName = event.getEventName();
			if(ownerTask.getParameterIndexMap().containsKey(eventName)){
				Integer parameterIndex = ownerTask.getParameterIndexMap().get(eventName);
				if(event.hasParameter()){
					try{
						if(((ParameterizedACLEvent)event).getParameterValue().get(parameterIndex).equals(expectedParameter)){
							theRepeatedTask.processEvent(event);
							System.out.println("Event:"+eventName+"with parameter"+expectedParameter);
						}  
					}
					catch(Exception e){
						PrintToScreen.printErrorToScreen("error occured while matching parmeters for a ForTask. EvenrName: " + eventName+" event is being rejected");
						e.printStackTrace();
					}				
				}
			}
			else{
				theRepeatedTask.processEvent(event);
			}
		}	
		
	}


	@Override
	public List<ACLEventProcessor> getConstituentsEventProcessors() {
		return theRepeatedTask.getConstituentsEventProcessors();
	}


	@Override
	public ACLEventProcessor getParentEventProcessor() {
		return this.ownerTask;
	}


	@Override
	public void setProcessorStatusToFail() {
		theRepeatedTask.setProcessorStatusToFail();
	}


	@Override
	public void skip() {
		theRepeatedTask.skip();		
	}


	@Override
	public List<String> getExpectedEvents() {
		return theRepeatedTask.getExpectedEvents();
	}


	@Override
	public Set<String> getForbiddenEvents() {
		return theRepeatedTask.getForbiddenEvents();
	}

}
