package MonitoringFramework.ACLClass;

import java.util.ArrayList;
import java.util.List;

import MonitoringFramework.classtrn.ScenarioTaskType;

public class ParallelTask extends ScenarioTask {
	
	private final List<ACLEventProcessor> taskConstituents;
	
	public ParallelTask(ACLScenario owner,Integer taskId) {
		super(owner, ScenarioTaskType.Dynamic, taskId);
		taskConstituents = new ArrayList<>();
	}
	
	public ParallelTask addAParallelTask(ACLEventProcessor task){
		taskConstituents.add(task);		
		return this;
	}

	
	public List<ACLEventProcessor> getTaskConstituents() {
		return taskConstituents;
	}
	
	@Override
	public void setUpToAcceptEvents(){
		this.taskStatus = EventProcessorState.SET;
		super.addACLEventProcessorsToTask(taskConstituents);
		this.getConstituentsEventProcessors().forEach((constituent) -> constituent.setUpToAcceptEvents()); //All the task may receive events at the same time.
	}

}
