package MonitoringFramework.IUTContract;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import MonitoringFramework.ACLClass.ACLContract;
import Scenario.Utility.StringUtils;
import IUT.server.logic.tables.UserTable;
public class UserTableContract extends ACLContract {
private Object iutType;
public static final List<String> EXPECTEDEVENTNAMES;
public static final Map<String, List<String>> SCENARIOTRIGGERMAP;
public static final String SELFNAME ="UserTableContract";
public UserTableContract(UserTable iutType) {
super();
this.iutType = iutType;
}
public UserTableContract() {}
static{
List<Class<?>> scenarioList=StringUtils.getScenarioListByContractName(SELFNAME);
List<String> triggerEvents=StringUtils.getAllTriggerEvents(scenarioList);
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(triggerEvents);
SCENARIOTRIGGERMAP = new HashMap<String, List<String>>();
EXPECTEDEVENTNAMES.forEach((eventName) -> SCENARIOTRIGGERMAP.put(eventName, getScenarioNamesbyTriggeringEvent(eventName,SELFNAME)));
}
public static List<String> getScenarioNamesbyTriggeringEvent(String triggeringEvent,String contract){
List<String> scenarioNameList = new ArrayList<>();
scenarioNameList=StringUtils.getAllScenarioNames(triggeringEvent,contract);
return scenarioNameList;
}
@Override
public void setBindpoint(Object instance) {
this.iutType = instance;
	}
@Override
public Object getBindpoint() {
return this.iutType;
}
@Override
public Map<String, List<String>> getScenarioTriggerMap() {
return SCENARIOTRIGGERMAP;
}
@Override
public List<String> getExpectedEventNames() {
return EXPECTEDEVENTNAMES;
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
public int hashCode() {
final int prime = 31;
int result = super.hashCode();
result = prime * result + ((iutType == null) ? 0 : iutType.hashCode());
return result;
}
@Override
public boolean equals(Object obj) {
if (this == obj) {
return true;
}
if (!super.equals(obj)) {
return false;
}
if (!(obj instanceof UserTableContract)) {
return false;
}
return true;
}
}
