package MonitoringFramework.classtrn;

public class EventToObserve {	
	
	private final String eventToObserve;
	private final Integer eventOccuranceCount;
	

	private final Boolean overflowAllowed;
	
	public EventToObserve(String eventToObserve, Integer eventOccuranceCount, Boolean overflowAllowed) {
		this.eventToObserve = eventToObserve;
		this.eventOccuranceCount = eventOccuranceCount;
		this.overflowAllowed = overflowAllowed;
	}
	
	public EventToObserve(String eventToObserve, Integer eventOccuranceCount) {
		this.eventToObserve = eventToObserve;
		this.eventOccuranceCount = eventOccuranceCount;
		this.overflowAllowed = false;
	}
	
	public EventToObserve(String eventToObserve) {
		this.eventToObserve = eventToObserve;
		this.eventOccuranceCount = 1; //by default it is 1
		this.overflowAllowed = false;
	}

	public Boolean getOverflowAllowed() {
		return overflowAllowed;
	}
	
	/**
	 * @return the eventToObserve
	 */
	public String getEventToObserve() {
		return eventToObserve;
	}

	/**
	 * @return the eventOccuranceCount
	 */
	public Integer getEventOccuranceCount() {
		return eventOccuranceCount;
	}
}
