package MonitoringFramework.classtrn;

import java.util.concurrent.atomic.AtomicInteger;

import MonitoringFramework.ACLClass.ACLEventType;

/**
 * 
 * @author hneedham
 * Not yet thread safe. 
 */
public class HasEventOccured {
	
	/**
	 * will return true even if the number of actual event occurrence goes over than expected one. 
	 * @param reequiredEventCount
	 */
	public HasEventOccured(Integer reequiredEventCount, Boolean overflowAllowed) {
		this.requiredEventCount = reequiredEventCount;
		//this.eventOccured = false; 
		this.overFlowAllowed = overflowAllowed;
	}
	
	
	private final Integer requiredEventCount;
	//private Boolean eventOccured = false;
	private AtomicInteger actualEventCount= new AtomicInteger(0);
	private Boolean overFlowAllowed = false;
		
	public Integer getRequiredEventCount() {
		return requiredEventCount;
	}
	
	public Boolean checkIfEventOccured() {
		return compareAndReturnResult();
	}
	
	private Boolean compareAndReturnResult(){
		if(overFlowAllowed){
			return actualEventCount.intValue()>= requiredEventCount;
		}
		else{
			//System.out.println("Comparing actual and required. Actual : "+ actualEventCount.intValue()+" required: " +requiredEventCount);
			return actualEventCount.intValue()== requiredEventCount;
		}
	}
	
	public void reportEventOccurance(ACLEventType event) {
		System.out.println("Event occurrance reported: "+ event.getEventName());
		this.actualEventCount.incrementAndGet();
		//System.out.println("Actual event count for event "+ event.getEventName() + " is: "+this.actualEventCount.get());
		event.Observe();
	}
	
	

}
