package MonitoringFramework.classtrn;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

public class LogManager {

	private static LogManager _instance = null;

	private static final String wDir = System.getProperty("user.dir");
	private static final String configFile = String.format("%s\\%s\\%s.properties", wDir, "properties", "log4j");

	private LogManager() {
		try {
			PropertyConfigurator.configure(configFile);
		} catch (Exception ex) {
		}
	}

	public static LogManager getInstance() {
		if (_instance == null) {
			synchronized (LogManager.class) {
				if (_instance == null) {
					_instance = new LogManager();
			}}}
		return _instance;
	}

	public void debug(Object o, String message) {
		Logger LOG = Logger.getLogger(o.getClass());
		LOG.debug(message);
	}

	public void info(Object o, String message) {
		Logger LOG = Logger.getLogger(o.getClass());
		LOG.info(message);
	}

	public void warning(Object o, String message) {
		Logger LOG = Logger.getLogger(o.getClass());
		LOG.warn(message);
	}

	public void error(Object o, String message) {
		Logger LOG = Logger.getLogger(o.getClass());
		LOG.error(message);
	}

	public void fatal(Object o, String message) {
		Logger LOG = Logger.getLogger(o.getClass());
		LOG.fatal(message);
	}
}
