package MonitoringFramework.classtrn;
import java.util.List;
import java.util.Map;

import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ACLScenario;

public class MetaScenario extends ACLScenario {	
	
	public static final String SELFNAME=null;
	public static final String TRIGGERNAME=null;
	public static final Boolean HASPARAMETERS= true; //each scenario instance to have it's own	
	public static final List<String> EXPECTEDEVENTNAMES=null;//written once at the time of object creation. DO NOT put the triggering event in this list.
	
	
	public void addEvent(String eventname){
		EXPECTEDEVENTNAMES.add(eventname);
	}
	
	/*
	 * To be called from Contract instance when a triggering event is received from blackboard or at the contract instance creation itself- if no event is required
	 * after instantioation contract should call registerForEvents on the scenario instance.
	 */
	public MetaScenario(ACLContract ownerContract,ACLEventType trigger) {	
		super(ownerContract, trigger);		
	}

	@Override
	protected void initializeParameterMap() {
	}
	
	
	@Override
	//adds the tasks for this scenario.
	protected void initializeTasksForScenario(){
	}

	@Override
	public String getListenerName() {
		// TODO Auto-generated method stub
		return SELFNAME;
	}


	@Override
	protected Map<String, List<ScenarioParameter>> getParameterMap() {
		return this.parameterMap;
	}


	@Override
	protected Boolean scenarioHasParameterizedEvents() {
		return HASPARAMETERS;
	}
	
	@Override
	public List<String> getExpectedEvents() {
		return EXPECTEDEVENTNAMES;
	}

	@Override
	protected String getExpectedTriggeringEventName() {
		// TODO Auto-generated method stub
		return TRIGGERNAME;
	}
	
}
