package MonitoringFramework.classtrn;

import java.util.List;

import org.apache.commons.lang3.tuple.Pair;

import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;

public class ObservabilityInformation {
	
	private Pair<String, Object> observabilityInformation; // The object in this pair can either be a contract instance or a scenario parameter, which resolves to a contract instance.
	private List<Object> parameters;
	private ObservabilityType observabilityType;
	
	public ObservabilityInformation(Pair<String, Object> observabilityInformation,List<Object> parameters,
			ObservabilityType observabilityType) {
		super();
		this.observabilityInformation = observabilityInformation;
		this.parameters=parameters;
		this.observabilityType = observabilityType;
	}
	/**
	 * @return the observabilityInformation
	 */
	public Pair<String, Object> getObservabilityInformation() {
		return observabilityInformation;
	}
	/**
	 * @return the observabilityType
	 */
	public ObservabilityType getObservabilityType() {
		return observabilityType;
	}
	
	public List<Object> getParameters(){
		return parameters;
	}
	
	
	
}
