package MonitoringFramework.classtrn;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import MonitoringFramework.ACLClass.ACLContract;

public class ReflectionUtility {
	
	public static Object getObservabilityReturnValue(String observability, Object contractInstanceVar) {
		Object returnevalue =null;
		try {
			Method observabilityMethod = contractInstanceVar.getClass().getMethod(observability, new Class[] {});//passing empty array signifies- no parameters for method.
			returnevalue = observabilityMethod.invoke(contractInstanceVar, new Object[]{});
		} catch (NoSuchMethodException | SecurityException e) {
			PrintToScreen.printToScreen("Error while resolving the variable. Observability: "+ observability+" could not be"+ "RETREIVED from contract class: " + contractInstanceVar.getClass());
			e.printStackTrace();						
		} catch (IllegalAccessException e) {
			PrintToScreen.printToScreen("Error while resolving the variable. Observability: "+ observability+" could not be"+ "INVOKED from contract class: " + contractInstanceVar.getClass());
			e.printStackTrace();
			
		} catch (IllegalArgumentException e) {
			PrintToScreen.printToScreen("Error while resolving the variable. Observability: "+ observability+" could not be"+ "INVOKED from contract class: " + contractInstanceVar.getClass());
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			PrintToScreen.printToScreen("Error while resolving the variable. Observability: "+ observability+" could not be"+ "INVOKED from contract class: " + contractInstanceVar.getClass());
			e.printStackTrace();
		}
		return returnevalue;
	}
	
	public static Object resolveContractInstance(ObservabilityInformation observabilityInformation) {
		Object ContractInstance = null;
		if(observabilityInformation.getObservabilityInformation().getRight().getClass().isAssignableFrom(ScenarioParameter.class)){
			//is it is scenario parameter then call getValue on the scenario parameter which should return a contractInstance type object 
			return ((ScenarioParameter)observabilityInformation.getObservabilityInformation().getRight()).getParameterValue();
		}	
		else if(observabilityInformation.getObservabilityInformation().getRight().getClass().getSuperclass().isAssignableFrom(ACLContract.class)){
			return observabilityInformation.getObservabilityInformation().getRight();
		}
				
		return ContractInstance;
	}

}
