//package MonitoringFramework.classtrn;
//
//import java.util.ArrayList;
//import java.util.Arrays;
//import edu.carleton.scs.university.core.Professor;
//import edu.carleton.scs.university.core.University;
//
///**
// * To be used for testing the Scenario-Event handling framework.
// * Simple Class which directely instantiates the contract classes and fires events to bypass the code injection and the complexity at responsibility level.
// * @author hneedham
// *
// */
//public class ScenarioEventTester {     
//	private static final CourseIUT COURSEIUTINSTANCE;
//	private static final CourseIUT ANOTHER_COURSEIUTINSTANCE;
//	private static final CourseIUTContract COURSE_IUT_CONTRACT ;
//	private static final CourseIUTContract ANOTHER_COURSE_IUT_CONTRACT ;
//	private static final ProfessorIUT PROFFIUTINSTANCE;
//	private static final ProfessorIUTContract PROFESSOR_IUT_CONTRACT;
//	private static final UniversityIUT UNIVERSITYIUTINSTANCE;
//	private static final UniversityIUTContract UNIVERSITU_IUT_CONTRACT;
//	
//	static {
//		UNIVERSITYIUTINSTANCE = MyIUTPool.universityIut;		
//		PROFFIUTINSTANCE = MyIUTPool.PROFESSORS.get(0);
//		COURSEIUTINSTANCE = MyIUTPool.COURSES.get(0);
//		
//		PROFESSOR_IUT_CONTRACT = new ProfessorIUTContract(PROFFIUTINSTANCE);
//		PROFFIUTINSTANCE.setTheBoundContract(PROFESSOR_IUT_CONTRACT);
//		
//		COURSE_IUT_CONTRACT = new CourseIUTContract(COURSEIUTINSTANCE);
//		COURSEIUTINSTANCE.setTheBoundContract(COURSE_IUT_CONTRACT);
//		
//		ANOTHER_COURSEIUTINSTANCE = MyIUTPool.COURSES.get(1);
//		ANOTHER_COURSE_IUT_CONTRACT = new CourseIUTContract(ANOTHER_COURSEIUTINSTANCE);
//		ANOTHER_COURSEIUTINSTANCE.setTheBoundContract(ANOTHER_COURSE_IUT_CONTRACT);
//		
//		UNIVERSITU_IUT_CONTRACT = new UniversityIUTContract(UNIVERSITYIUTINSTANCE);
//	}
//
//	/**
//	 * 
//	 * @param args
//	 */
//	public static void main(String[] args) {		 
//		ScenarioEventTester eventSource = new ScenarioEventTester();
//		//ACLContract proffContract = new ProfessorIUTContract(new ProfessorIUT()); //This is done by Oracle but this is just a test class.
//		PROFESSOR_IUT_CONTRACT.registerForACLEvents();
//		UNIVERSITU_IUT_CONTRACT.registerForACLEvents();
//		
//		eventsWithParameterList(eventSource);
//		//eventsWithParameterList(eventSource); //1.
//		//eventsWithParametersAndObservability(eventSource);	//2. show event of order, contract matching, not observe (choice/alternative)
//		//forLoopEventTest(eventSource); //3. shows for loop and repeated event and indices support
//		//failedForLoopEventTest(eventSource); //4.proof of for loop fail catch (out of order and not firing all events)
//		//eachLoopEventTest(eventSource); //5. executing same course twice will also show that parameter matching does not accept the wrong course
//		//parallelTaskTest(eventSource); //6.
//		BlackBoard.getInstance().notifyIUTExit();
//		while(!BlackBoard.getInstance().isTimeToshutDownEventNotification()){
//			try {
//				Thread.sleep(1000* Constants.WAITFOREVENTPROCESSING);
//			} catch (InterruptedException e) {
//				e.printStackTrace();
//			}
//		}
//		PROFESSOR_IUT_CONTRACT.getScenarioInstanceStatusAfterIUTExit();
//		UNIVERSITU_IUT_CONTRACT.getScenarioInstanceStatusAfterIUTExit();
//		
//
//		
//	}
////
////	public static void eventOrderProof(ScenarioEventTester eventSource) {	
//////		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis())); //This should trigger the scenario
//////		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis())); //This should trigger another scenario
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()), "MRX")); //This should trigger the scenario
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()), "MRY")); //This should trigger the scenario
////		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.MONTHELAPSEDEVENT, System.currentTimeMillis()));
////		//BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis())); 
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis()),"MRX"));
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis()),"MRY"));
////		
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.TERMINATEPROFESSOREVENT, System.currentTimeMillis()),"MRY"));
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.TERMINATEPROFESSOREVENT, System.currentTimeMillis()),"MRX"));
////		
////		//BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.STUDENTSREMOVEDFROMCLASS, System.currentTimeMillis())); 
////		return;
////	}
//	
//	public static void eventsWithParameterList(ScenarioEventTester eventSource) {		
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
////				new ArrayList<Object>(Arrays.asList("MRX",4000)))); //This should trigger the scenario
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()), 
////				new ArrayList<Object>(Arrays.asList("MRY",4500)))); //This should trigger the scenario
////		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.MONTHELAPSEDEVENT, System.currentTimeMillis()));
////		
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis()),
////				new ArrayList<Object>(Arrays.asList("MRY",4500))));
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis()),
////				new ArrayList<Object>(Arrays.asList("MRX",4000))));
////		
////		
//////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.TERMINATEPROFESSOREVENT, System.currentTimeMillis()),"MRY"));
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.TERMINATEPROFESSOREVENT, System.currentTimeMillis()),"MRX"));
////		
//////		List<String> expectedEventName=PROFESSOR_IUT_CONTRACT.getExpectedEventNames();
//////		System.out.println(expectedEventName.size());
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList("MRX",4000)))); //This should trigger the scenario
//		//BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()), 
//		//		new ArrayList<Object>(Arrays.asList("MRY",4500)))); //This should trigger the scenario
//		//BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource,StringUtils.MONTHELAPSEDEVENT, System.currentTimeMillis()));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.MONTHELAPSEDEVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList("MRX",4000)))); 
//		//BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis()),
//		//		new ArrayList<Object>(Arrays.asList("MRY",4500))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PAYPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList("MRX",4000))));
//		
//		
////		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.TERMINATEPROFESSOREVENT, System.currentTimeMillis()),"MRY"));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.TERMINATEPROFESSOREVENT, System.currentTimeMillis()),"MRX"));
//		
////		List<String> expectedEventName=PROFESSOR_IUT_CONTRACT.getExpectedEventNames();
////		System.out.println(expectedEventName.size());
//		
//		return;
//	}
//	
//	public static void eventsWithParametersAndObservability(ScenarioEventTester eventSource) {
//		final ACLEvent teachCourseEvent = new ACLEvent(eventSource,StringUtils.TEACHCOURSE, System.currentTimeMillis());
//		teachCourseEvent.setUniquelyObservable(true);
//		final ACLEvent monthElapsedEvent = new ACLEvent(eventSource,StringUtils.MONTHELAPSEDEVENT, System.currentTimeMillis());
//		monthElapsedEvent.setUniquelyObservable(true);
//		final ACLEvent announceAssignment = new ACLEvent(eventSource,StringUtils.ANNOUNCEASSIGNMENT, System.currentTimeMillis());
//		announceAssignment.setUniquelyObservable(true);
//		final ACLEvent markAssginmentEvent = new ACLEvent(eventSource,StringUtils.MARKASSIGNMENT, System.currentTimeMillis());
//		markAssginmentEvent.setUniquelyObservable(true);
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT)))); //This should trigger the scenario	
//		
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(teachCourseEvent,new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));		
//		BlackBoard.getInstance().fireAnEvent(monthElapsedEvent);
////		try {
////			Thread.sleep(100);
////		} catch (InterruptedException e) {
////			e.printStackTrace();
////		}
//		
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(announceAssignment,	new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT)))); //Show this out of order!!!
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(teachCourseEvent),new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));			
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(monthElapsedEvent));
////		try {
////			Thread.sleep(100);
////		} catch (InterruptedException e) {			
////			e.printStackTrace();
////		}
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(announceAssignment),new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.ANNOUNCEPROJECT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(teachCourseEvent),new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));			
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(monthElapsedEvent));
////		try {
////			Thread.sleep(100);
////		} catch (InterruptedException e) {
////			e.printStackTrace();
////		}
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(markAssginmentEvent,	new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(markAssginmentEvent), new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.MARKPROJECT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(teachCourseEvent),new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));			
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(monthElapsedEvent));
//
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.HOLDEXAM, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.GETFEEDBACK, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT,	COURSE_IUT_CONTRACT))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.ANNOUNEFINALRESULT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));//COURSE_IUT_CONTRACT
//		
//		return;
//	}
//	
//	
//	public static void forLoopEventTest(ScenarioEventTester eventSource) {		
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT)))); 
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMSTART, System.currentTimeMillis()));
//		PROFFIUTINSTANCE.setTheCouseAssigned(ANOTHER_COURSEIUTINSTANCE);
//		for(CourseIUT course: PROFFIUTINSTANCE.getTheCousesAssigned()){
//			ACLContract couseContract = course.getTheBoundContract();
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSIN, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFFESORSUBMITSTHECOURSEMATERIAL, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT, couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.COURSEAVAILABLE, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSOUT, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT))));
//		}
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis()));
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis()));
//		
//		return;
//	}
//	
//	
//	public static void failedForLoopEventTest(ScenarioEventTester eventSource) {		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT)))); 
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMSTART, System.currentTimeMillis()));
//		PROFFIUTINSTANCE.setTheCouseAssigned(ANOTHER_COURSEIUTINSTANCE);
//		//for(CourseIUT course: PROFFIUTINSTANCE.getTheCousesAssigned()){
//			ACLContract couseContract = ANOTHER_COURSE_IUT_CONTRACT;//COURSE_IUT_CONTRACT;
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSIN, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFFESORSUBMITSTHECOURSEMATERIAL, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT, couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.COURSEAVAILABLE, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSOUT, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT))));
//
//			couseContract = COURSE_IUT_CONTRACT;//COURSE_IUT_CONTRACT;//ANOTHER_COURSE_IUT_CONTRACT
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSIN, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFFESORSUBMITSTHECOURSEMATERIAL, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT,couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.COURSEAVAILABLE, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSOUT, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT))));
//		//}
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis()));
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis())); //Firing twice..it is test of indices
//		
//		return;
//	}
//	
//	
//	public static void eachLoopEventTest(ScenarioEventTester eventSource) {		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT)))); 
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMSTART, System.currentTimeMillis()));
//		PROFFIUTINSTANCE.setTheCouseAssigned(ANOTHER_COURSEIUTINSTANCE);
//		//for(CourseIUT course: PROFFIUTINSTANCE.getTheCousesAssigned()){
//			ACLContract couseContract = ANOTHER_COURSE_IUT_CONTRACT;//COURSE_IUT_CONTRACT;
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSIN, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT,couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFFESORSUBMITSTHECOURSEMATERIAL, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT, couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.COURSEAVAILABLE, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSOUT, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT,couseContract))));
//
//			couseContract = ANOTHER_COURSE_IUT_CONTRACT;//COURSE_IUT_CONTRACT;//ANOTHER_COURSE_IUT_CONTRACT
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSIN, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT,couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFFESORSUBMITSTHECOURSEMATERIAL, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT, couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.COURSEAVAILABLE, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(couseContract))));
//			BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.PROFESSORLOGSOUT, System.currentTimeMillis()),
//					new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT,couseContract))));
//		//}
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis()));
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis())); //Firing twice..it is test of indices
//		
//		return;
//	}
//	
//	
//	public static void parallelTaskTest(ScenarioEventTester eventSource) {
//		final ACLEvent teachCourseEvent = new ACLEvent(eventSource,StringUtils.TEACHCOURSE, System.currentTimeMillis());
//		final ACLEvent helpStudentsWithProject = new ACLEvent(eventSource,StringUtils.HELPSTUDENTSWITHPROJECT, System.currentTimeMillis());
//		
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(new ACLEvent(eventSource,StringUtils.CREATEPROFESSOREVENT, System.currentTimeMillis()),
//				new ArrayList<Object>(Arrays.asList(PROFESSOR_IUT_CONTRACT)))); 
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMSTART, System.currentTimeMillis()));
//	
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(teachCourseEvent,new ArrayList<Object>(Arrays.asList(COURSE_IUT_CONTRACT))));
//		BlackBoard.getInstance().fireAnEvent(new ParameterizedACLEvent(helpStudentsWithProject,new ArrayList<Object>(Arrays.asList(COURSEIUTINSTANCE.getProjectName()))));//COURSEIUTINSTANCE.getProjectName()
//			
//		BlackBoard.getInstance().fireAnEvent(new ACLEvent(eventSource, StringUtils.ANNOUNCETERMENDED, System.currentTimeMillis()));
//
//		
//		return;
//	}
//
//}
