package MonitoringFramework.classtrn;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

public class ScenarioThreadFactory {
	
	private static ScenarioThreadFactory _instance = null;
	private ExecutorService executorService;
	
	private ScenarioThreadFactory() {	
		executorService = Executors.newCachedThreadPool();
	}
	
	
	public static ScenarioThreadFactory getInstance () {     
	      if (_instance == null) {
	         synchronized (BlackBoard.class) {
	            if (_instance == null) {               
	               _instance = new ScenarioThreadFactory();
	            }}}
	      return _instance;
	   }
	
	public Future<?> runScenarioThread(Runnable scenarioInstance){
		return executorService.submit(scenarioInstance);
	}
	
	public void shutDownAndWaitForScenaioThreadCompletion(){
		this.executorService.shutdown();
		try {
			this.executorService.awaitTermination(Long.MAX_VALUE, TimeUnit.NANOSECONDS);
		} catch (InterruptedException e) {
			System.out.println("Some exception occured while trying to shut down the scenario thread factory: "+ e.getMessage());
			e.printStackTrace();
		}
	}

}
