package MonitoringFramework.classtrn;

public class TraceElement {
	public String CtClass;
	public String IutClass;
	public Integer CtHashCode;
	public Integer IutHashCode;
	
	public TraceElement (Object ctClass, Object iutClass) {
		CtClass = ctClass.getClass().getSimpleName();
		CtHashCode = ctClass.hashCode();
		IutClass = iutClass.getClass().getSimpleName();
		IutHashCode = iutClass.hashCode();
	}
	
	public String toString () {
		StackTraceElement[] elements = Thread.currentThread().getStackTrace();
		String s = String.format ("[%s, %s(), %d] <- [%s, %s(), %d ]\n"
				                   , CtClass, elements[3].getMethodName(), CtHashCode
				                   , IutClass, elements[4].getMethodName(), IutHashCode);
		return s;
	}

	public void printStackTrace () {
		StackTraceElement[] elements = Thread.currentThread().getStackTrace();
		System.err.println(">>>\t>>>\t>>>");
		for (StackTraceElement e: elements) {
			System.out.printf("Class name %s Method %s LineNumber %d HashCode %d\n"
			,e.getClassName()
			,e.getMethodName()
			,e.getLineNumber()
			,e.getClass().hashCode());
		}
		System.err.println("<<<\t<<<\t<<<");
	}
}
