package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="AddUser",owner="UserTableContract",trigger="userAdditionRequested")
public class AddUserScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="AddUserScenario";
public static final String TRIGGERNAME="userAdditionRequested";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public AddUserScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("reprotUserExists");
expectedEvents.add("generateNewUserId");
expectedEvents.add("newUserCreated");
expectedEvents.add("userAdditionCompleted");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("generateNewUserId", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))));
parameterMap.put("newUserCreated", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))));
parameterMap.put("userAdditionCompleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesUserExistCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesUserExist", parameterMap.get(TRIGGERNAME).get(2)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesUserExistCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("reprotUserExists", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("generateNewUserId", 1)).and(new EventToObserve("newUserCreated")).and(new EventToObserve("userAdditionCompleted")));
getConstituentsEventProcessors().add(st1);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
