package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="BorrowLoanCopy",owner="LoanTableContract",trigger="loanRequested")
public class BorrowLoanCopyScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="BorrowLoanCopyScenario";
public static final String TRIGGERNAME="loanRequested";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public BorrowLoanCopyScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("reportUserInvalid");
expectedEvents.add("checkDoesISBNInvalid");
expectedEvents.add("reportISBNInvalid");
expectedEvents.add("checkDoesCopyNumberInvalid");
expectedEvents.add("reportCopyNumberInvalid");
expectedEvents.add("checkDoesExceedLimit");
expectedEvents.add("reportExceedLimit");
expectedEvents.add("checkHasFee");
expectedEvents.add("reportHasFee");
expectedEvents.add("checkDoesItemAvailable");
expectedEvents.add("loanAdded");
expectedEvents.add("itemBorrowed");
expectedEvents.add("reportItemNotAvailable");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("loanAdded", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
parameterMap.put("itemBorrowed", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesUserInvalidCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesUserInvalid", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesUserInvalidCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportUserInvalid", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesISBNInvalid", 1)));
getConstituentsEventProcessors().add(st1);
ConditionToBeChecked DoesISBNInvalidCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesISBNInvalid", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(1))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st2 = new ChoiceAlternativeTask(this, 2, DoesISBNInvalidCondition);
((ChoiceAlternativeTask)st2).setChoiceTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportISBNInvalid", 1)));
((ChoiceAlternativeTask)st2).setAlternativeTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesCopyNumberInvalid", 1)));
getConstituentsEventProcessors().add(st2);
ConditionToBeChecked DoesCopyNumberInvalidCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesCopyNumberInvalid", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st3 = new ChoiceAlternativeTask(this, 3, DoesCopyNumberInvalidCondition);
((ChoiceAlternativeTask)st3).setChoiceTask(new ACLEventExpression(st3, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportCopyNumberInvalid", 1)));
((ChoiceAlternativeTask)st3).setAlternativeTask(new ACLEventExpression(st3, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesExceedLimit", 1)));
getConstituentsEventProcessors().add(st3);
ConditionToBeChecked DoesExceedLimitCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesExceedLimit", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st4 = new ChoiceAlternativeTask(this, 4, DoesExceedLimitCondition);
((ChoiceAlternativeTask)st4).setChoiceTask(new ACLEventExpression(st4, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportExceedLimit", 1)));
((ChoiceAlternativeTask)st4).setAlternativeTask(new ACLEventExpression(st4, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkHasFee", 1)));
getConstituentsEventProcessors().add(st4);
ConditionToBeChecked HasFeeCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("HasFee", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st5 = new ChoiceAlternativeTask(this, 5, HasFeeCondition);
((ChoiceAlternativeTask)st5).setChoiceTask(new ACLEventExpression(st5, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportHasFee", 1)));
((ChoiceAlternativeTask)st5).setAlternativeTask(new ACLEventExpression(st5, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesItemAvailable", 1)));
getConstituentsEventProcessors().add(st5);
ConditionToBeChecked DoesItemAvailableCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesItemAvailable", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st6 = new ChoiceAlternativeTask(this, 6, DoesItemAvailableCondition);
((ChoiceAlternativeTask)st6).setChoiceTask(new ACLEventExpression(st6, EventProcessorState.CREATED).observeEvent(new EventToObserve("loanAdded", 1)).and(new EventToObserve("itemBorrowed")));
((ChoiceAlternativeTask)st6).setAlternativeTask(new ACLEventExpression(st6, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportItemNotAvailable", 1)));
getConstituentsEventProcessors().add(st6);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
