package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="ItemAddition",owner="ItemTableContract",trigger="itemAdditionRequested")
public class ItemAdditionScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="ItemAdditionScenario";
public static final String TRIGGERNAME="itemAdditionRequested";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public ItemAdditionScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("itemAdditionCompleted");
expectedEvents.add("reportTitleDoesNotExist");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("itemAdditionCompleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesTitleExistCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesTitleExist", parameterMap.get(TRIGGERNAME).get(1)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesTitleExistCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("itemAdditionCompleted", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportTitleDoesNotExist", 1)));
getConstituentsEventProcessors().add(st1);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
