package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="RemoveItem",owner="ItemTableContract",trigger="itemDeletionRequested")
public class RemoveItemScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="RemoveItemScenario";
public static final String TRIGGERNAME="itemDeletionRequested";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public RemoveItemScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("checkDoesItemHasLoan");
expectedEvents.add("reportItemDoesNotExist");
expectedEvents.add("informItemHasLoan");
expectedEvents.add("itemDeleted");
expectedEvents.add("itemDeletionCompleted");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("itemDeleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))));
parameterMap.put("itemDeletionCompleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesItemExistCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesItemExist", parameterMap.get(TRIGGERNAME).get(2)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesItemExistCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesItemHasLoan", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportItemDoesNotExist", 1)));
getConstituentsEventProcessors().add(st1);
ConditionToBeChecked DoesItemHasLoanCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesItemHasLoan", parameterMap.get(TRIGGERNAME).get(2)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st2 = new ChoiceAlternativeTask(this, 2, DoesItemHasLoanCondition);
((ChoiceAlternativeTask)st2).setChoiceTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("informItemHasLoan", 1)));
((ChoiceAlternativeTask)st2).setAlternativeTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("itemDeleted", 1)).and(new EventToObserve("itemDeletionCompleted")));
getConstituentsEventProcessors().add(st2);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
