package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="RemoveTitle",owner="TitleTableContract",trigger="titleDeletionRequested")
public class RemoveTitleScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="RemoveTitleScenario";
public static final String TRIGGERNAME="titleDeletionRequested";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public RemoveTitleScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("informTitleNotExist");
expectedEvents.add("checkLoan");
expectedEvents.add("informTitleHasLoan");
expectedEvents.add("requestDeletion");
expectedEvents.add("deleteItem");
expectedEvents.add("titleDeleted");
expectedEvents.add("titleDeletionCompleted");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("requestDeletion", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))));
parameterMap.put("deleteItem", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),new ScenarioParameter(null, Pair.of("getItems(ISBN", parameterMap.get(TRIGGERNAME).get(1))))));
parameterMap.put("titleDeleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))));
parameterMap.put("titleDeletionCompleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesTitleExistCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesTitleExist", parameterMap.get(TRIGGERNAME).get(1)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), false, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesTitleExistCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("informTitleNotExist", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkLoan", 1)));
getConstituentsEventProcessors().add(st1);
ConditionToBeChecked titleHasLoanCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("titleHasLoan", parameterMap.get(TRIGGERNAME).get(1)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st2 = new ChoiceAlternativeTask(this, 2, titleHasLoanCondition);
((ChoiceAlternativeTask)st2).setChoiceTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("informTitleHasLoan", 1)));
((ChoiceAlternativeTask)st2).setAlternativeTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("requestDeletion", 1)));
getConstituentsEventProcessors().add(st2);
ForTask st3 = new ForTask(this, 3, new ObservabilityInformation(Pair.of("getItems", parameterMap.get(TRIGGERNAME).get(1)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.VALUETYPE));
st3.addEventParameterIndexInformation("deleteItem", 1);
ScenarioTask taskToBeRepeated;
Integer numberOfTimesTaskisTobeRepeated = st3.getNumberOfForTaskConstituents();
for (int i = 0; i < numberOfTimesTaskisTobeRepeated; i++) {
taskToBeRepeated = new StaticScenarioTaskType(this, 4);
taskToBeRepeated.addACLEventProcessorToTask(new ACLEventExpression(taskToBeRepeated, EventProcessorState.CREATED).observeEvent(new EventToObserve("deleteItem", 1)));
st3.setTaskToBeRepeated(taskToBeRepeated,i);
}
getConstituentsEventProcessors().add(st3);
ScenarioTask st5 = new StaticScenarioTaskType(this,5);
st5.addACLEventProcessorToTask(new ACLEventExpression(st5, EventProcessorState.CREATED).observeEvent(new EventToObserve("titleDeleted",1)));
getConstituentsEventProcessors().add(st5);
ScenarioTask st6 = new StaticScenarioTaskType(this,6);
st6.addACLEventProcessorToTask(new ACLEventExpression(st6, EventProcessorState.CREATED).observeEvent(new EventToObserve("titleDeletionCompleted",1)));
getConstituentsEventProcessors().add(st6);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
