package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="RenewLoan",owner="LoanTableContract",trigger="'renewLoanRequested'")
public class RenewLoanScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="RenewLoanScenario";
public static final String TRIGGERNAME="'renewLoanRequested'";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public RenewLoanScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("reportExceedLimit");
expectedEvents.add("checkHasFee");
expectedEvents.add("reportHasFee");
expectedEvents.add("checkDoesLoanExist");
expectedEvents.add("checkDoesExceedRenewLimit");
expectedEvents.add("reportLoanDoesNotExist");
expectedEvents.add("reportExceedRenewLimit");
expectedEvents.add("loanRenewed");
expectedEvents.add("loanRenewedCompeleted");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("loanRenewed", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
parameterMap.put("loanRenewedCompeleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesExceedLimitCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesExceedLimit", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesExceedLimitCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportExceedLimit", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkHasFee", 1)));
getConstituentsEventProcessors().add(st1);
ConditionToBeChecked HasFeeCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("HasFee", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st2 = new ChoiceAlternativeTask(this, 2, HasFeeCondition);
((ChoiceAlternativeTask)st2).setChoiceTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportHasFee", 1)));
((ChoiceAlternativeTask)st2).setAlternativeTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesLoanExist", 1)));
getConstituentsEventProcessors().add(st2);
ConditionToBeChecked DoesLoanExistCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesLoanExist", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st3 = new ChoiceAlternativeTask(this, 3, DoesLoanExistCondition);
((ChoiceAlternativeTask)st3).setChoiceTask(new ACLEventExpression(st3, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesExceedRenewLimit", 1)));
((ChoiceAlternativeTask)st3).setAlternativeTask(new ACLEventExpression(st3, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportLoanDoesNotExist", 1)));
getConstituentsEventProcessors().add(st3);
ConditionToBeChecked DoesExceedRenewLimitCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesExceedRenewLimit", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st4 = new ChoiceAlternativeTask(this, 4, DoesExceedRenewLimitCondition);
((ChoiceAlternativeTask)st4).setChoiceTask(new ACLEventExpression(st4, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportExceedRenewLimit", 1)));
((ChoiceAlternativeTask)st4).setAlternativeTask(new ACLEventExpression(st4, EventProcessorState.CREATED).observeEvent(new EventToObserve("loanRenewed", 1)).and(new EventToObserve("loanRenewedCompeleted")));
getConstituentsEventProcessors().add(st4);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
