package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="ReturnLoanCopy",owner="LoanTableContract",trigger="returnLoanRequested")
public class ReturnLoanCopyScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="ReturnLoanCopyScenario";
public static final String TRIGGERNAME="returnLoanRequested";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public ReturnLoanCopyScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("checkDoesLoanOverdue");
expectedEvents.add("reportLoanDoesNotExist");
expectedEvents.add("applyOverDueFee");
expectedEvents.add("loanDeleted");
expectedEvents.add("loanDeletionCompleted");
expectedEvents.add("itemReturned");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null),new ScenarioParameter(null))));
parameterMap.put("applyOverDueFee", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))));
parameterMap.put("loanDeleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
parameterMap.put("loanDeletionCompleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
parameterMap.put("itemReturned", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))));
}
@Override
protected void initializeTasksForScenario(){
ConditionToBeChecked DoesLoanExistCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesLoanExist", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st1 = new ChoiceAlternativeTask(this, 1, DoesLoanExistCondition);
((ChoiceAlternativeTask)st1).setChoiceTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("checkDoesLoanOverdue", 1)));
((ChoiceAlternativeTask)st1).setAlternativeTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("reportLoanDoesNotExist", 1)));
getConstituentsEventProcessors().add(st1);
ConditionToBeChecked DoesLoanOverdueCondition =new ConditionToBeChecked(new ObservabilityInformation(Pair.of("DoesLoanOverdue", parameterMap.get(TRIGGERNAME).get(3)), new ArrayList<Object>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0),parameterMap.get(TRIGGERNAME).get(1),parameterMap.get(TRIGGERNAME).get(2))),ObservabilityType.BOOLEANTYPE), true, Operator.Equalto);
ScenarioTask st2 = new ChoiceAlternativeTask(this, 2, DoesLoanOverdueCondition);
((ChoiceAlternativeTask)st2).setChoiceTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("applyOverDueFee", 1)));
((ChoiceAlternativeTask)st2).setAlternativeTask(new ACLEventExpression(st2, EventProcessorState.CREATED).observeEvent(new EventToObserve("loanDeleted", 1)).and(new EventToObserve("loanDeletionCompleted")).and(new EventToObserve("itemReturned")));
getConstituentsEventProcessors().add(st2);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
