package Scenario;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import org.apache.commons.collections4.list.SetUniqueList;
import org.apache.commons.lang3.tuple.Pair;
import MonitoringFramework.ACLClass.ACLContract;
import MonitoringFramework.ACLClass.ACLEventExpression;
import MonitoringFramework.ACLClass.ACLEventType;
import MonitoringFramework.ACLClass.ForTask;
import MonitoringFramework.ACLClass.ScenarioTask;
import MonitoringFramework.classtrn.EventToObserve;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ScenarioParameter;
import MonitoringFramework.classtrn.StaticScenarioTaskType;
import Scenario.MyAnnotation.MyAnnotations.Scenario;
import MonitoringFramework.ACLClass.ChoiceAlternativeTask;
import MonitoringFramework.classtrn.ConditionToBeChecked;
import MonitoringFramework.classtrn.ObservabilityInformation;
import MonitoringFramework.classtrn.ConditionToBeChecked.ObservabilityType;
import MonitoringFramework.ACLClass.ParallelTask;
import MonitoringFramework.classtrn.ConditionToBeChecked.Operator;
@Scenario(name="UseDeletionFollowsUserCreation",owner="UserTableContract",trigger="userAdditionCompleted")
public class UseDeletionFollowsUserCreationScenario extends MonitoringFramework.ACLClass.ACLScenario{
public static final String SELFNAME ="UseDeletionFollowsUserCreationScenario";
public static final String TRIGGERNAME="userAdditionCompleted";
public static final Boolean HASPARAMETERS= true; 
public static final List<String> EXPECTEDEVENTNAMES;
public UseDeletionFollowsUserCreationScenario(ACLContract ownerContract,ACLEventType trigger) {
super(ownerContract, trigger);
}
static{
List<String> expectedEvents=new ArrayList<String>();
expectedEvents.add("userDeletionCompleted");
EXPECTEDEVENTNAMES = SetUniqueList.setUniqueList(expectedEvents);
}
@Override
protected void initializeParameterMap() {
parameterMap.put(TRIGGERNAME, new ArrayList<>(Arrays.asList(new ScenarioParameter(null))));
parameterMap.put("userDeletionCompleted", new ArrayList<>(Arrays.asList(parameterMap.get(TRIGGERNAME).get(0))));
}
@Override
protected void initializeTasksForScenario(){
ScenarioTask st1 = new StaticScenarioTaskType(this,1);
st1.addACLEventProcessorToTask(new ACLEventExpression(st1, EventProcessorState.CREATED).observeEvent(new EventToObserve("userDeletionCompleted",1)));
getConstituentsEventProcessors().add(st1);
}
@Override
public String getListenerName() {
return SELFNAME;
}
@Override
protected Map<String, List<ScenarioParameter>> getParameterMap() {
return this.parameterMap;
}
@Override
protected Boolean scenarioHasParameterizedEvents() {
return HASPARAMETERS;
}
@Override
public List<String> getExpectedEvents() {
return EXPECTEDEVENTNAMES;
}
@Override
protected String getExpectedTriggeringEventName() {
return TRIGGERNAME;
}
}
