package controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class ConfigController {
	public static final String currentDir=System.getProperty("user.dir");
	public static final File metadataDir=new File(currentDir,"/resource/metadata");
	public static final File configFile=new File(metadataDir,"systemConfig.properties");
	public static final Properties prop = new Properties();
	
	public File initialize() throws IOException{
		if(!configFile.exists()){
			configFile.createNewFile();
		}
		return configFile;
	}
	
	public void write(String key,String value){
		try(FileOutputStream fos=new FileOutputStream(this.initialize())){
			prop.setProperty(key, value);
			prop.store(fos, "System Config");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public String read(String key){
		String result="";
		try(FileInputStream fis=new FileInputStream(this.initialize())){
			prop.load(fis);
			if(!(prop.getProperty(key)== null)){
				result=prop.getProperty(key);
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return result;
	}
	
	
	

}
