package controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Properties;
import java.util.Scanner;
import Utils.ConstantsUtil;

public class JScenarioBindingController {
	private static final ConfigController configController=new ConfigController();
	private static final ScenarioBindingController scenarioBindingController=new ScenarioBindingController();
	private static final EventBindingController eventBindingController=new EventBindingController();
	private static final String JScenaioDir=configController.read(ConstantsUtil.JScenarioDirectory);
	private static final String JScenarioUtilsDir="/Scenario/Utility";
	private static final File MethodUtils=new File(JScenaioDir,JScenarioUtilsDir+File.separator+"MethodUtils.java");
	private static final File ScenarioUtils=new File(JScenaioDir,JScenarioUtilsDir+File.separator+"ScenarioUtils.java");
	public static final Properties propScenarios = new Properties();
	public static final Properties propFiringEvents=new Properties();
	public static final String IUTDir="IUT";
	
	
	public void deleteMethodUtils(){
		String file=headerMethodUtilsBuilder()+footerMethodUtilsBuilder();
		try(FileWriter writer =new FileWriter(MethodUtils, false)){
			writer.write(file);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void deleteScenarioUtils(){
		String file=headerScenarioUtilsBuilder()+footerScenarioUtilsBuilder();
		try(FileWriter writer =new FileWriter(ScenarioUtils, false)){
			writer.write(file);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void deleteAll(){
		deleteMethodUtils();
		deleteScenarioUtils();
	}
	
	public static String singleLineMEMethodUtilsBuilder(String methodName,String eventName){
		return "MethodUtils.methods.put(\""+methodName+"\", \""+eventName+"\");";
	}
	public static String singleLineMCMethodUtilsBuilder(String methodName,String className){
		return "MethodUtils.owners.put(\""+methodName+"\", Class.forName(\""+IUTDir+"."+className+"\"));";
	}
	
	public static String methodExtractor(String methodStr){
		String methodName="";
		methodName=methodStr.substring(0, methodStr.lastIndexOf("("));
		String[] temp=methodName.split(" ");
		methodName=temp[temp.length-1];
		return methodName;
	}
	
	
	public static String headerMethodUtilsBuilder(){
		return "package Scenario.Utility;\nimport java.util.HashMap;\nimport java.util.Map;\npublic class MethodUtils {\npublic static Map<String,String> methods =new HashMap<String,String>();\npublic static Map<String,Class<?>> owners=new HashMap<String,Class<?>>();\nstatic{\ntry{";
	}
	
	public static String mainBodyMethodUtilsBuilder(){
		String mainBody="";
		try(FileInputStream fis=new FileInputStream(eventBindingController.initialize())){
			propFiringEvents.load(fis);
			Enumeration<?> e = propFiringEvents.propertyNames();
		    while (e.hasMoreElements()) {
		    	String clasName=(String) e.nextElement();
		    	String methodStr=propFiringEvents.getProperty(clasName);
		    	String[] methodList=methodStr.split(";");
		    	if(methodList.length>1){
				for(String method:methodList){
					//buildOwner,extrct method name
					String ownerStr=singleLineMCMethodUtilsBuilder(methodExtractor(method),clasName);
					mainBody=mainBody+ownerStr+"\n";
					
					String[] subMethodStr=method.split(":");
					if(subMethodStr.length>1){
						String[] eventStrList=subMethodStr[1].split(",");
						if(eventStrList.length>0){
							for(String event:eventStrList){
								//buildEvent,extrct method name
								String eventStr=singleLineMEMethodUtilsBuilder(methodExtractor(method),event);
								mainBody=mainBody+eventStr+"\n";
							}
						}
					}
				}
		    	
		    }
		    }
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		return mainBody;
	}
	public static String footerMethodUtilsBuilder(){
		return "} catch (ClassNotFoundException e) {\ne.printStackTrace();\n}\n}\npublic static String lookup(String methodName){\nreturn MethodUtils.methods.get(methodName);\n}\npublic static Class<?> lookupOwner(String methodName) {\nreturn MethodUtils.owners.get(methodName);\n}\n}";
	}

	public static void methodUtilsBuilder(){
		String file=headerMethodUtilsBuilder()+mainBodyMethodUtilsBuilder()+footerMethodUtilsBuilder();
		try(FileWriter writer =new FileWriter(MethodUtils, false)){
			writer.write(file);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static String singleLineScenarioUtilsBuilder(String scenarioName){
		return "public static final String "+(scenarioName).toUpperCase()+" = \""+scenarioName+"\";";
	}
	public static String headerScenarioUtilsBuilder(){
		return "package Scenario.Utility;\npublic class ScenarioUtils {\n";
	}
	public static String mainBodyScenarioUtilsBuilder(){
		String mainBody="";
		List<String> activeScenarioList=getActiveScenarioList();
		for(int i=0;i<activeScenarioList.size();i++){
			String singleLine=singleLineScenarioUtilsBuilder(activeScenarioList.get(i))+"\n";
			mainBody=mainBody+singleLine;
		}
		return mainBody;
	}
	public static String footerScenarioUtilsBuilder(){
		return "}";
	}
	
	public static List<String> getActiveScenarioList(){
		List<String> activeScenarioList=new ArrayList<String>();
		try (FileInputStream fis = new FileInputStream(scenarioBindingController.initialize())) {
			propScenarios.load(fis);
			Enumeration<?> e = propScenarios.propertyNames();
		    while (e.hasMoreElements()) {
		    	String className=(String) e.nextElement();
				String scenarioStr = propScenarios.getProperty(className);
				if (scenarioStr != null) {
					String[] scenarioList = scenarioStr.split(";");
					if (scenarioList.length > 0) {
						for (int i = 0; i < scenarioList.length; i++) {
							String[] status = scenarioList[i].split(":");
							if (status.length > 1) {
								if (status[1].equals("true")) {
									activeScenarioList.add(status[0]);
								}
							}
						}
					}
				}
				}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return activeScenarioList;
	}
	
	public static List<String> getActiveContractList(){
		List<String> activeContractList=new ArrayList<String>();
		try (FileInputStream fis = new FileInputStream(scenarioBindingController.initialize())) {
			propScenarios.load(fis);
			Enumeration<?> e = propScenarios.propertyNames();
		    while (e.hasMoreElements()) {
		    	String className=(String) e.nextElement();
		    	activeContractList.add(className);
				}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return activeContractList;
	}
	
	public static void scenarioUtilsBuilder(){
		String file=headerScenarioUtilsBuilder()+mainBodyScenarioUtilsBuilder()+footerScenarioUtilsBuilder();
		try(FileWriter writer =new FileWriter(ScenarioUtils, false)){
			writer.write(file);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	public String methodLookUp(String eventName){
		String result="";
		Scanner scanner = null;
		try {
			scanner = new Scanner(MethodUtils);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		while (scanner.hasNextLine()) {
		   String lineFromFile = scanner.nextLine();
		   if(lineFromFile.contains("MethodUtils.methods.put(\"") && lineFromFile.contains("\""+eventName+"\");")){
			   //check if commented out
			   if(!lineFromFile.trim().startsWith("//")){
				   result=lineFromFile.substring(lineFromFile.indexOf("(\"")+2,lineFromFile.lastIndexOf("\","));
				   break;
			   }
		   }
		}
		return result;
	}
	
	public String classLookUp(String eventName){
		String methodName=methodLookUp(eventName);
		String result="";
		Scanner scanner = null;
		try {
			scanner = new Scanner(MethodUtils);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		while (scanner.hasNextLine()) {
		   String lineFromFile = scanner.nextLine();
		   if(lineFromFile.contains("MethodUtils.owners.put(\""+methodName)){
			   //check if commented out
			   if(!lineFromFile.trim().startsWith("//")){
				   result=lineFromFile.substring(lineFromFile.lastIndexOf("(\"")+2,lineFromFile.lastIndexOf("\""));
				   break;
			   }
		   }
		}
		return result;
	}
	

	
	
	

}
