package controller;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class ResetController {
	private static final EventBindingController eventBindingController=new EventBindingController();
	private static final JScenarioBindingController jscenarioBindingController=new JScenarioBindingController();
	private static final ScenarioBindingController scenarioBindingController=new ScenarioBindingController();
	private static final ScenarioTranslationController scenarioTranslationController=new ScenarioTranslationController();
	private static final TestSuitesController testSuiteController=new TestSuitesController();
	
	public Runnable eventBindingCleanUp(){
		Runnable task = () -> {eventBindingController.deleteAll();};
		return task;
	}
	
	public Runnable jscenarioBindingCleanUp(){
		Runnable task = () -> {jscenarioBindingController.deleteAll();};
		return task;
	}
	
	public Runnable scenarioBindingCleanUp(){
		Runnable task = () -> {scenarioBindingController.deleteAll();};
		return task;
	}
	
	public Runnable scenarioTranslationCleanUp(){
		Runnable task = () -> {scenarioTranslationController.deleteAll();};
		return task;
	}
	
	public Runnable testSuiteCleanUp(){
		Runnable task = () -> {testSuiteController.deleteAll();};
		return task;
	}
	
	public void cleanAll(){
		ExecutorService executorService = Executors.newFixedThreadPool(5);
		executorService.execute(eventBindingCleanUp());
		executorService.execute(jscenarioBindingCleanUp());
		executorService.execute(scenarioBindingCleanUp());
		executorService.execute(scenarioTranslationCleanUp());
		executorService.execute(testSuiteCleanUp());
		executorService.shutdown();
	}

}
