package layout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileSystemView;

import Utils.ConstantsUtil;
import controller.ConfigController;
import controller.EventBindingController;
import controller.ResetController;

import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JButton;
import javax.swing.JFileChooser;

import java.awt.event.ActionListener;
import java.io.File;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.awt.event.ActionEvent;
import javax.swing.JTextField;

public class EnvironmentSetting extends JFrame {

	private JPanel contentPane;
	private JTextField textField;
	private JTextField textField_1;
	private static final ConfigController configController=new ConfigController();
	private static final EventBindingController eventBindingController=new EventBindingController();
	private static final ResetController resetController=new ResetController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					EnvironmentSetting frame = new EnvironmentSetting();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public EnvironmentSetting(){
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JLabel lblStep = new JLabel("Step 1 : Set up the testing environment");
		lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
		lblStep.setBounds(33, 38, 317, 32);
		contentPane.add(lblStep);
		
		JButton btnNextStep = new JButton("Next Step");
		btnNextStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				//open next step, get all the fire events before next stop
				ExecutorService executorService = Executors.newSingleThreadExecutor();
				Runnable task=() -> {
					configController.write(ConstantsUtil.JScenarioDirectory, textField_1.getText());
					configController.write(ConstantsUtil.IUTDirectory, textField_1.getText()+"/IUT");
				};
				executorService.execute(task);
				Runnable task1 = () -> {
					eventBindingController.getAllClasses(new File(configController.read(ConstantsUtil.IUTDirectory)));
				};
				executorService.execute(task1);
				Runnable task2 = () ->{
					setVisible(false);
					EventsDefinitionWithImport ed=new EventsDefinitionWithImport();
					ed.setVisible(true);
				};
				executorService.execute(task2);
				executorService.shutdown();
			}
		});
		btnNextStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNextStep.setBounds(671, 437, 123, 45);
		contentPane.add(btnNextStep);
		
//		JLabel lblIutDirectory = new JLabel("IUT Directory :");
//		lblIutDirectory.setFont(new Font("Times New Roman", Font.PLAIN, 18));
//		lblIutDirectory.setBounds(33, 121, 123, 32);
//		contentPane.add(lblIutDirectory);
		
		JLabel lblJsenarioDirectory = new JLabel("JSenario Directory :");
		lblJsenarioDirectory.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblJsenarioDirectory.setBounds(33, 186, 150, 32);
		contentPane.add(lblJsenarioDirectory);
		
//		//IUT text field,need some prefixed values
//		textField = new JTextField();
//		textField.setBounds(196, 127, 416, 22);
//		contentPane.add(textField);
//		textField.setColumns(10);
//		textField.setText(configController.read(ConstantsUtil.IUTDirectory));
		
		//Jscenario text field,need some prefixed values
		textField_1 = new JTextField();
		textField_1.setColumns(10);
		textField_1.setBounds(196, 192, 416, 22);
		contentPane.add(textField_1);
//		textField_1.setEnabled(false);
		textField_1.setText(configController.read(ConstantsUtil.JScenarioDirectory));
	
		
//		JButton btnGetIut = new JButton("File");
//		btnGetIut.addActionListener(new ActionListener() {
//			public void actionPerformed(ActionEvent e) {
//				//get IUT directory(src), open  a file selector frame
//				JFileChooser chooser = new JFileChooser(FileSystemView.getFileSystemView().getHomeDirectory());
//				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
//				int returnValue = chooser.showOpenDialog(null);
//				if (returnValue == JFileChooser.APPROVE_OPTION) {
//					File selectedFile = chooser.getCurrentDirectory();
//					configController.write(ConstantsUtil.IUTDirectory, selectedFile.toString());
//					textField.setText(selectedFile.toString());
//					
//				}
//			}
//		});
//		btnGetIut.setFont(new Font("Times New Roman", Font.PLAIN, 18));
//		btnGetIut.setBounds(654, 126, 97, 25);
//		contentPane.add(btnGetIut);
		
		JButton btnGet = new JButton("File");
		btnGet.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//get JScenario,  opend a file selector frame
				JFileChooser chooser = new JFileChooser(FileSystemView.getFileSystemView().getHomeDirectory());
				chooser.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
				int returnValue = chooser.showOpenDialog(null);
				if (returnValue == JFileChooser.APPROVE_OPTION) {
					File selectedFile = chooser.getCurrentDirectory();
					textField_1.setText(selectedFile.toString());
					
				}
			}
		});
		btnGet.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnGet.setBounds(654, 191, 97, 25);
		contentPane.add(btnGet);
		
		JButton btnNewButton = new JButton("Clean Testing Environment");
		btnNewButton.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//clean all the metadata
				ExecutorService executorService = Executors.newSingleThreadExecutor();
				Runnable task = () -> {
					//start cleaning
					//disable next button
					btnNextStep.setEnabled(false);
					resetController.cleanAll();
				};
				executorService.execute(task);
				Runnable task1 = () -> {
					//enable next button when clean finished
					btnNextStep.setEnabled(true);
				};
				executorService.execute(task1);
				executorService.shutdown();
			}
		});
		btnNewButton.setBounds(33, 121, 235, 32);
		contentPane.add(btnNewButton);
	}
}
