package layout;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import controller.ConfigController;
import controller.EventBindingController;
import controller.JScenarioBindingController;

public class EventsDefinition extends JFrame {

	private JPanel contentPane;
	private JComboBox comboBox_class;
	private JComboBox comboBox_method;
	private DefaultComboBoxModel comboBoxModel_class;
	private DefaultComboBoxModel comboBoxModel_method;
	private static final ConfigController configController=new ConfigController();
	private static final EventBindingController eventBindingController=new EventBindingController();
	private static final JScenarioBindingController jscenarioBindingCOntroller=new JScenarioBindingController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					EventsDefinition frame = new EventsDefinition();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public EventsDefinition() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		JLabel lblStep = new JLabel("Step 2 : Define firing events");
		lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
		lblStep.setBounds(33, 38, 317, 32);
		contentPane.add(lblStep);

		JButton btnNextStep = new JButton("Next Step");
		btnNextStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// open next step, generate the two binding files in JScenario
				ExecutorService executorService = Executors.newSingleThreadExecutor();
				Runnable task1 = () -> {
					jscenarioBindingCOntroller.methodUtilsBuilder();
				};
				executorService.execute(task1);
				Runnable task2 = () ->{
					setVisible(false);
					ScenarioDefinition sd = new ScenarioDefinition();
					sd.setVisible(true);
				};
				executorService.execute(task2);
				executorService.shutdown();

			}
		});
		btnNextStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNextStep.setBounds(671, 437, 123, 45);
		contentPane.add(btnNextStep);

		JButton btnPrevStep = new JButton("Prev Step");
		btnPrevStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// go back to previous step
				setVisible(false);
				EnvironmentSetting es = new EnvironmentSetting();
				es.setVisible(true);
			}
		});
		btnPrevStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnPrevStep.setBounds(33, 437, 123, 45);
		contentPane.add(btnPrevStep);

		JLabel lblIutDirectory = new JLabel("Import pre-defined firing events :");
		lblIutDirectory.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblIutDirectory.setBounds(33, 121, 289, 32);
		contentPane.add(lblIutDirectory);

		JCheckBox chckbxYes = new JCheckBox("Yes");
		chckbxYes.setSelected(false);
		chckbxYes.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		chckbxYes.setBounds(671, 125, 113, 25);
		contentPane.add(chckbxYes);
		// add listner to siwth the frames
		chckbxYes.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (chckbxYes.isSelected()) {
					setVisible(false);
					EventsDefinitionWithImport ed = new EventsDefinitionWithImport();
					ed.setVisible(true);
				}
			}
		});

		JLabel lblExample = new JLabel("Browsing by class and method name : ");
		lblExample.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblExample.setBounds(33, 186, 289, 32);
		contentPane.add(lblExample);

		JLabel lblSelectClassTo = new JLabel("1. Select Class to browse:");
		lblSelectClassTo.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblSelectClassTo.setBounds(61, 250, 289, 32);
		contentPane.add(lblSelectClassTo);

		// give value to the dropbox, need to be replaced by real data producer,
		// get class name
		List<String> keys = eventBindingController.getAllProperty();
		String[] classStr = new String[keys.size()];
		classStr = keys.toArray(classStr);
		comboBoxModel_class=new DefaultComboBoxModel(classStr);
		comboBox_class = new JComboBox(comboBoxModel_class);
		comboBox_class.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		comboBox_class.setBounds(342, 255, 452, 22);
		contentPane.add(comboBox_class);
		// add listen to handle the table change to refresh the table
		comboBox_class.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JComboBox cb = (JComboBox) e.getSource();
				String className = (String) cb.getSelectedItem();
				// refresh the method drop list
				List<String> methods = eventBindingController.getMethodList(className);
				String[] methodStr = new String[methods.size()];
				methodStr = methods.toArray(methodStr);
				comboBoxModel_method=new DefaultComboBoxModel(methodStr);
				comboBox_method.setModel(comboBoxModel_method);
			}
		});

		JLabel lblSelectMethod = new JLabel("2. Select Method to browse:");
		lblSelectMethod.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblSelectMethod.setBounds(61, 310, 289, 32);
		contentPane.add(lblSelectMethod);

		// give value to the dropbox, need to be replaced by real data producer,
		// get method name
		String className = (String)comboBox_class.getSelectedItem();
		List<String> methods = eventBindingController.getMethodList(className);
		String[] methodStr = new String[methods.size()];
		methodStr = methods.toArray(methodStr);
		comboBoxModel_method=new DefaultComboBoxModel(methodStr);
		comboBox_method = new JComboBox(comboBoxModel_method);
		comboBox_method.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		comboBox_method.setBounds(342, 315, 452, 22);
		contentPane.add(comboBox_method);
		// add listen to handle the table change to refresh the table
		comboBox_method.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JComboBox cb = (JComboBox) e.getSource();
				String methodName = (String) cb.getSelectedItem();
				// refresh the method drop list, open the eidtor
				String classNameStr=comboBox_class.getSelectedItem().toString();
	        	String methodNameStr=comboBox_method.getSelectedItem().toString();
	        	FireEventsEditor editor=new FireEventsEditor(classNameStr,methodNameStr);
	        	setVisible(false);
	        	editor.setVisible(true);
			}
		});

	}

}
