package layout;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;
import controller.ConfigController;
import controller.EventBindingController;
import controller.JScenarioBindingController;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;
import javax.swing.JTable;

public class EventsDefinitionWithImport extends JFrame {

	private JPanel contentPane;
	private JTable table;
	private DefaultTableModel tableModel;
	private static final ConfigController configController = new ConfigController();
	private static final EventBindingController eventBindingController = new EventBindingController();
	private static final JScenarioBindingController jscenarioBindingCOntroller=new JScenarioBindingController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					EventsDefinitionWithImport frame = new EventsDefinitionWithImport();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public EventsDefinitionWithImport() {

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		JLabel lblStep = new JLabel("Step 2 : Define firing events");
		lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
		lblStep.setBounds(33, 38, 317, 32);
		contentPane.add(lblStep);

		JButton btnNextStep = new JButton("Next Step");
		btnNextStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// open next step, generate the two binding files in JScenario
				ExecutorService executorService = Executors.newSingleThreadExecutor();
				Runnable task1 = () -> {
					jscenarioBindingCOntroller.methodUtilsBuilder();
				};
				executorService.execute(task1);
				Runnable task2 = () ->{
					setVisible(false);
					ScenarioDefinition sd = new ScenarioDefinition();
					sd.setVisible(true);
				};
				executorService.execute(task2);
				executorService.shutdown();

			}
		});
		btnNextStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNextStep.setBounds(671, 437, 123, 45);
		contentPane.add(btnNextStep);

		JButton btnPrevStep = new JButton("Prev Step");
		btnPrevStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// go back to previous step
				setVisible(false);
				EnvironmentSetting es = new EnvironmentSetting();
				es.setVisible(true);
			}
		});
		btnPrevStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnPrevStep.setBounds(33, 437, 123, 45);
		contentPane.add(btnPrevStep);

		JLabel lblIutDirectory = new JLabel("Import pre-defined firing events :");
		lblIutDirectory.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblIutDirectory.setBounds(33, 121, 289, 32);
		contentPane.add(lblIutDirectory);

		JCheckBox chckbxYes = new JCheckBox("Yes");
		chckbxYes.setSelected(true);
		chckbxYes.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		chckbxYes.setBounds(671, 125, 113, 25);
		contentPane.add(chckbxYes);
		// add listner to siwth the frames
		chckbxYes.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (!chckbxYes.isSelected()) {
					setVisible(false);
					EventsDefinition ed = new EventsDefinition();
					ed.setVisible(true);
				}
			}
		});

		JLabel lblBrowingByClass = new JLabel("Browsing by class :");
		lblBrowingByClass.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblBrowingByClass.setBounds(33, 186, 150, 32);
		contentPane.add(lblBrowingByClass);

		// give value to the dropbox, need to be replaced by real data producer
		List<String> keys = eventBindingController.getAllProperty();
		String[] classStr = new String[keys.size()];
		classStr = keys.toArray(classStr);
		JComboBox comboBox = new JComboBox(classStr);
		comboBox.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		comboBox.setBounds(342, 191, 452, 22);
		contentPane.add(comboBox);
		// add listen to handle the table change to refresh the table
		comboBox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JComboBox cb = (JComboBox) e.getSource();
				String className = (String) cb.getSelectedItem();
				String[] columnNames = { "Method", "Events" };
				Object[][] data = eventBindingController.getTable(className);
				// refresh the table
				tableModel = new DefaultTableModel(data, columnNames){
					public boolean isCellEditable(int row, int column) {
						return false;
					}
				};
				table.setModel(tableModel);
			}
		});

		// get table date,need to be replaced by real date producer
		String className = (String) comboBox.getSelectedItem();
		String[] columnNames = { "Method", "Events" };
		Object[][] data = eventBindingController.getTable(className);
		tableModel = new DefaultTableModel(data, columnNames) {
			public boolean isCellEditable(int row, int column) {
				return false;
			}
		};
		table = new JTable(tableModel);
		table.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		table.getTableHeader().setFont(new Font("Times New Roman", Font.PLAIN, 18));
		table.setBounds(264, 307, 1, 1);
		table.setRowHeight(25);
		
		table.addMouseListener(new MouseAdapter() {
		    @Override
		    public void mouseClicked(MouseEvent evt) {
		        int row = table.rowAtPoint(evt.getPoint());
		        int col = table.columnAtPoint(evt.getPoint());
		        if (row >= 0 && col >= 0) {
					String className = comboBox.getSelectedItem().toString();
					String methodName = table.getValueAt(row, 0).toString();
					FireEventsEditor editor = new FireEventsEditor(className, methodName);
					setVisible(false);
					editor.setVisible(true);
		        }
		    }
		});
		contentPane.add(table);

		JScrollPane scrollPane = new JScrollPane(table);
		scrollPane.setBounds(33, 231, 761, 180);
		contentPane.add(scrollPane);
	}
}
