package layout;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Font;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.border.EmptyBorder;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultHighlighter;
import javax.swing.text.Document;
import javax.swing.text.Highlighter;
import javax.swing.text.JTextComponent;

import Utils.ConstantsUtil;
import controller.ConfigController;
import controller.EventBindingController;

import javax.swing.JLabel;
import javax.swing.JEditorPane;
import javax.swing.JFrame;

import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.awt.event.ActionEvent;

public class FireEventsEditor extends JDialog {

	private final JPanel contentPanel =   new JPanel();
	private static final ConfigController configController = new ConfigController();
	private static final EventBindingController eventBindingController = new EventBindingController();
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			String className = "test";
			String methodName = "test";
			FireEventsEditor dialog = new FireEventsEditor(className, methodName);
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 * 
	 * @param methodName
	 * @param className
	 */
	public FireEventsEditor(String className, String methodName) {
		this.addWindowListener(new WindowAdapter() 
		{
		  public void windowClosed(WindowEvent e)
		  {
			EventsDefinitionWithImport ed=new EventsDefinitionWithImport();
			ed.setVisible(true);
		  }
		});
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblStep = new JLabel("Please add implementation for firing events : ");
			lblStep.setBounds(33, 38, 364, 32);
			lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
			contentPanel.add(lblStep);

			JLabel lblNewLabel = new JLabel(className + " -> " + methodName);
			lblNewLabel.setBounds(33, 121, 761, 32);
			lblNewLabel.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			contentPanel.add(lblNewLabel);
			
			JLabel lblExample = new JLabel("Example : FireEvent.FireAnEvent(\"Event Name\",new ArrayList<Object>(\"Parameter Mapping\"))");
			lblExample.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			lblExample.setBounds(33, 186, 761, 32);
			contentPanel.add(lblExample);
		}
		
		
		JEditorPane editorPane = new JEditorPane();
		editorPane.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		editorPane.setBounds(264, 307, 1, 1);
		editorPane.setText(eventBindingController.getClassContent(className));
		highlight(editorPane, methodName);
		contentPanel.add(editorPane);
		

		JScrollPane scrollPane = new JScrollPane(editorPane);
		scrollPane.setBounds(33, 231, 761, 180);
		contentPanel.add(scrollPane);
		
		{

			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Save");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						//save the changes to the class,check if the fire statement valid
						String editorContent=editorPane.getText();
						ExecutorService executorService = Executors.newSingleThreadExecutor();
						Runnable task = () -> {
						eventBindingController.saveFile(className,editorContent);
						};
						executorService.execute(task);
						Runnable task1 = () -> {
						eventBindingController.getAllClasses(new File(configController.read(ConstantsUtil.IUTDirectory)));
						};
						executorService.execute(task1);
						Runnable task2 = () ->{
							setVisible(false);
							EventsDefinitionWithImport ed=new EventsDefinitionWithImport();
							ed.setVisible(true);
						};
						executorService.execute(task2);
						executorService.shutdown();
					}
				});
				okButton.setActionCommand("Save");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
						EventsDefinitionWithImport ed=new EventsDefinitionWithImport();
						ed.setVisible(true);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
	
	public static void highlight(JTextComponent textComp, String pattern) {
        try {
            Highlighter hilite = textComp.getHighlighter();
            Document doc = textComp.getDocument();
            String text = doc.getText(0, doc.getLength());
            int pos = 0;
            while ((pos = text.indexOf(pattern, pos)) >= 0) {
                hilite.addHighlight(pos, pos + pattern.length(), new DefaultHighlighter.DefaultHighlightPainter(Color.YELLOW));
                pos += pattern.length();
            }
        } catch (BadLocationException e) {
        }
    }
}
