package layout;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;

import Utils.ConstantsUtil;
import controller.EventBindingController;
import controller.ScenarioBindingController;
import controller.TestSuitesController;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JCheckBox;

public class FullReport extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JEditorPane editorPane = new JEditorPane();
	private static final TestSuitesController testSuitesController = new TestSuitesController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			// ScenarioEditor dialog = new ScenarioEditor();
			FullReport dialog = new FullReport();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public FullReport() {
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblStep = new JLabel("Full tetsing report : ");
			lblStep.setBounds(33, 38, 364, 32);
			lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
			contentPanel.add(lblStep);

		}

		editorPane = new JEditorPane();
		editorPane.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		editorPane.setBounds(264, 307, 1, 1);
		editorPane.setText(testSuitesController.getFullReportContent());
		contentPanel.add(editorPane);

		JScrollPane scrollPane = new JScrollPane(editorPane);
		scrollPane.setBounds(33, 107, 761, 383);
		contentPanel.add(scrollPane);

		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}


}
