package layout;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableModel;

import controller.ScenarioTranslationController;
import controller.TestSuitesController;

public class ReportResult extends JFrame {

	private JPanel contentPane;
	private JTable table;
	private DefaultTableModel tableModel;
	private static final TestSuitesController testSuitesController=new TestSuitesController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					ReportResult frame = new ReportResult();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public ReportResult() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JLabel lblStep = new JLabel("Step 5 : Show testing report");
		lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
		lblStep.setBounds(33, 38, 317, 32);
		contentPane.add(lblStep);

		JButton btnNextStep = new JButton("Finish");
		btnNextStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				setVisible(false);

			}
		});
		btnNextStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNextStep.setBounds(671, 437, 123, 45);
		contentPane.add(btnNextStep);

		JButton btnPrevStep = new JButton("Prev Step");
		btnPrevStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// go back to previous step
				setVisible(false);
				RunTestPlan es = new RunTestPlan();
				es.setVisible(true);
			}
		});
		btnPrevStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnPrevStep.setBounds(33, 437, 123, 45);
		contentPane.add(btnPrevStep);
		
		String[] columnNames = {"Scenario","Instance Id","State"};
		Object[][] data = testSuitesController.getReportTable();
		tableModel = new DefaultTableModel(data, columnNames) {
			public boolean isCellEditable(int row, int column) {
				return false;
			}
		};
		table = new JTable(tableModel);
		table.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		table.getTableHeader().setFont(new Font("Times New Roman", Font.PLAIN, 18));
		table.setBounds(264, 307, 1, 1);
		table.setRowHeight(25);
		contentPane.add(table);
		
		JScrollPane scrollPane = new JScrollPane(table);
		scrollPane.setBounds(33, 231, 761, 180);
		contentPane.add(scrollPane);
		
		JButton btnNewButton = new JButton("Export");
		btnNewButton.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				//export the result table
				//export the full report
				FullReport fr = new FullReport();
				fr.setVisible(true);
			}
		});
		btnNewButton.setBounds(33, 121, 123, 32);
		contentPane.add(btnNewButton);
	}

}
