package layout;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;
import controller.TestSuitesController;

public class RunTestPlan extends JFrame {

	private JPanel contentPane;
	private static final TestSuitesController testSuitesController = new TestSuitesController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					RunTestPlan frame = new RunTestPlan();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public RunTestPlan() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);
		
		JLabel lblStep = new JLabel("Step 4 : Run Test Plan");
		lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
		lblStep.setBounds(33, 38, 317, 32);
		contentPane.add(lblStep);

		JButton btnPrevStep = new JButton("Prev Step");
		btnPrevStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// go back to previous step
				setVisible(false);
				ScenarioDefinition es = new ScenarioDefinition();
				es.setVisible(true);
			}
		});
		btnPrevStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnPrevStep.setBounds(33, 437, 123, 45);
		contentPane.add(btnPrevStep);
		
		JEditorPane editorPane = new JEditorPane();
		editorPane.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		editorPane.setBounds(264, 307, 1, 1);
		editorPane.setText(testSuitesController.getEditableTestPlanContent());
		contentPane.add(editorPane);
		
		JScrollPane scrollPane = new JScrollPane(editorPane);
		scrollPane.setBounds(33, 231, 761, 180);
		contentPane.add(scrollPane);
		
		JLabel lblExample = new JLabel("Please input a list of your test plan : ");
		lblExample.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		lblExample.setBounds(33, 186, 761, 32);
		contentPane.add(lblExample);
		
		JButton btnNextStep = new JButton("Next Step");
		btnNextStep.setEnabled(false);
		btnNextStep.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				// open next step
				ExecutorService executorService = Executors.newSingleThreadExecutor();
				Runnable task = () -> {
					//alert finished and then go to next stage
					setVisible(false);
					ReportResult sd = new ReportResult();
					sd.setVisible(true); 
				};
				executorService.execute(task);
				executorService.shutdown();

			}
		});
		btnNextStep.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNextStep.setBounds(671, 437, 123, 45);
		contentPane.add(btnNextStep);
		
		JButton btnNewButton = new JButton("Run");
		btnNewButton.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String editorContent = editorPane.getText();
				ExecutorService executorService = Executors.newSingleThreadExecutor();
				Runnable task = () -> {
					testSuitesController.saveTestPlan(editorContent);
				};
				executorService.execute(task);
				Runnable task1 = () -> {
					testSuitesController.publicTester();
				};
				executorService.execute(task1);
				Runnable task2 = () -> {
					try {
						testSuitesController.testerRunner();
					} catch (Exception e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
				};
				executorService.execute(task2);
				Runnable task3 = () -> {
					//alert test finished 
					btnNextStep.setEnabled(true);
				};
				executorService.execute(task3);
				executorService.shutdown();
			}
		});
		btnNewButton.setBounds(33, 121, 123, 32);
		contentPane.add(btnNewButton);
	}

}
