package layout;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;

import Utils.ConstantsUtil;
import controller.EventBindingController;
import controller.ScenarioBindingController;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JCheckBox;

public class ScenarioEditor extends JDialog {

	private final JPanel contentPanel = new JPanel();
	private JTextField textField = new JTextField();
	private JComboBox comboBox = new JComboBox();
	private JEditorPane editorPane = new JEditorPane();
	private JCheckBox chckbxOn = new JCheckBox();
	private static final EventBindingController eventBindingController = new EventBindingController();
	private static final ScenarioBindingController scenarioBindingController = new ScenarioBindingController();

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			// ScenarioEditor dialog = new ScenarioEditor();
			ScenarioEditor dialog = new ScenarioEditor("test", "test");
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ScenarioEditor() {
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblStep = new JLabel("Please define a scenario : ");
			lblStep.setBounds(33, 38, 364, 32);
			lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
			contentPanel.add(lblStep);

			JLabel lblNewLabel = new JLabel("New scenario name : ");
			lblNewLabel.setBounds(33, 121, 289, 32);
			lblNewLabel.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			contentPanel.add(lblNewLabel);

			textField = new JTextField();
			textField.setBounds(378, 127, 416, 22);
			contentPanel.add(textField);
			textField.setColumns(10);

			JLabel lblBrowingByClass = new JLabel("Select a contract :");
			lblBrowingByClass.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			lblBrowingByClass.setBounds(33, 186, 330, 32);
			contentPanel.add(lblBrowingByClass);

			// give value to the dropbox, need to be replaced by real data
			// producer
			List<String> keys = eventBindingController.getAllProperty();
			String[] classStr = new String[keys.size()];
			classStr = keys.toArray(classStr);
			comboBox = new JComboBox(classStr);
			comboBox.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			comboBox.setBounds(342, 191, 452, 22);
			contentPanel.add(comboBox);

		}

		editorPane = new JEditorPane();
		editorPane.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		editorPane.setBounds(264, 307, 1, 1);
		contentPanel.add(editorPane);

		JScrollPane scrollPane = new JScrollPane(editorPane);
		scrollPane.setBounds(33, 231, 761, 180);
		contentPanel.add(scrollPane);

		chckbxOn = new JCheckBox("On");
		chckbxOn.setSelected(true);
		chckbxOn.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		chckbxOn.setBounds(33, 454, 113, 25);
		contentPanel.add(chckbxOn);

		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Save");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						// save the changes to the class,check if the fire
						// statement valid
						String scenarioName = textField.getText();
						String className = (String) comboBox.getSelectedItem();
						String editorContent = editorPane.getText();
						boolean status = chckbxOn.isSelected();
						if (!scenarioBindingController.checkScenarioName(scenarioName)) {
							ExecutorService executorService = Executors.newSingleThreadExecutor();
							Runnable task = () -> {
								scenarioBindingController.createScenario(scenarioName, className, editorContent,
										status);
							};
							executorService.execute(task);
							Runnable task1 = () -> {
								setVisible(false);
								ScenarioDefinition sd = new ScenarioDefinition();
								sd.setVisible(true);
							};
							executorService.execute(task1);
							executorService.shutdown();

						} else {
							JOptionPane.showMessageDialog(null, scenarioName + " already exists. ",
									"Duplicate Scenario Name", JOptionPane.ERROR_MESSAGE);
						}
					}
				});
				okButton.setActionCommand("Save");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
						ScenarioDefinition sd = new ScenarioDefinition();
						sd.setVisible(true);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public ScenarioEditor(String className, String scenarioName) {
		setBounds(200, 200, 850, 600);
		setTitle("JScenario");
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblStep = new JLabel("Please review an existing scenario : ");
			lblStep.setBounds(33, 38, 364, 32);
			lblStep.setFont(new Font("Times New Roman", Font.BOLD, 18));
			contentPanel.add(lblStep);

			JLabel lblNewLabel = new JLabel("Scenario name : ");
			lblNewLabel.setBounds(33, 121, 289, 32);
			lblNewLabel.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			contentPanel.add(lblNewLabel);

			textField = new JTextField();
			textField.setBounds(378, 127, 416, 22);
			textField.setText(scenarioName);
			textField.setEditable(false);
			contentPanel.add(textField);
			textField.setColumns(10);

			JLabel lblBrowingByClass = new JLabel("Contract name :");
			lblBrowingByClass.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			lblBrowingByClass.setBounds(33, 186, 330, 32);
			contentPanel.add(lblBrowingByClass);

			JTextField textField1 = new JTextField();
			textField1.setEditable(false);
			textField1.setBounds(378, 191, 416, 22);
			textField1.setText(className);
			contentPanel.add(textField1);
			textField1.setColumns(10);

			JButton btnNewButton = new JButton("Delete");
			btnNewButton.setFont(new Font("Times New Roman", Font.PLAIN, 18));
			btnNewButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					// delete this scnenario
					ExecutorService executorService = Executors.newSingleThreadExecutor();
					Runnable task = () -> {
						scenarioBindingController.deleteScenario(scenarioName, className);
					};
					executorService.execute(task);
					Runnable task1 = () -> {
						setVisible(false);
						ScenarioDefinition sd = new ScenarioDefinition();
						sd.setVisible(true);
					};
					executorService.execute(task1);
					executorService.shutdown();
				}
			});
			btnNewButton.setBounds(697, 454, 97, 25);
			contentPanel.add(btnNewButton);
		}
		editorPane = new JEditorPane();
		editorPane.setBounds(264, 307, 1, 1);
		editorPane.setText(scenarioBindingController.getEditableScenarioContent(scenarioName));
		contentPanel.add(editorPane);

		JScrollPane scrollPane = new JScrollPane(editorPane);
		scrollPane.setBounds(33, 231, 761, 180);
		contentPanel.add(scrollPane);

		chckbxOn = new JCheckBox("On");
		chckbxOn.setFont(new Font("Times New Roman", Font.PLAIN, 18));
		chckbxOn.setBounds(33, 454, 113, 25);
		chckbxOn.setSelected(scenarioBindingController.getScenarioStatus(className, scenarioName));
		contentPanel.add(chckbxOn);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Save");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						// save the changes to the class,check if the fire
						// statement valid
						String editorContent = editorPane.getText();
						boolean status = chckbxOn.isSelected();
						ExecutorService executorService = Executors.newSingleThreadExecutor();
						Runnable task = () -> {
							scenarioBindingController.updateScenario(scenarioName, className, editorContent, status);
						};
						executorService.execute(task);
						Runnable task1 = () -> {
							setVisible(false);
							ScenarioDefinition sd = new ScenarioDefinition();
							sd.setVisible(true);
						};
						executorService.execute(task1);
						executorService.shutdown();
					}
				});
				okButton.setActionCommand("Save");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						setVisible(false);
						ScenarioDefinition sd = new ScenarioDefinition();
						sd.setVisible(true);
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}
}
